#!/usr/bin/env python

import  MySQLdb

db = MySQLdb.connect(user="cv", passwd="cv", db="eso")
c = db.cursor()

c.execute("""CREATE TABLE expeditions (
             base        tinyint not null default 1,
	     doc_no      int unsigned not null,
	     doc_date    date not null,
	     carid       mediumint not null default 0,
	     name        char(32) not null,
	     
	     dtypes      char(80) not null default '',
	     objects     char(10) not null default '',
	     printed     tinyint not null default 0,
	     date        datetime not null,
	     oper        char(32) not null default ''
	     )""")

c.execute("""CREATE TABLE expedcatalog (
	     doc_counter  int(10) zerofill not null default '0000000000',
	     doc_no       int unsigned not null,
	     doc_date     date not null,
	     userid       int unsigned not null default 1,
	     partn_dn     varchar(10) not null,
	     partn_sname  varchar(20) not null default '',
	     sweight      decimal(10,3) not null,
	     price        decimal(10,3) not null,
	     sel          tinyint not null default 1
	     
	     )""")

c.execute("""CREATE TABLE tempexped (
	     doc_counter  int(10) zerofill not null default '0000000000',
	     doc_no       int unsigned not null,
	     doc_date     date not null,
	     userid       int unsigned not null default 1,
	     partn_dn     varchar(10) not null,
	     partn_sname  varchar(20) not null default '',
	     sweight      decimal(10,3) not null,
	     price        decimal(10,3) not null,
	     sel          tinyint not null default 1
	     
	     )""")
	     
db.close()
print "Ok"
