import os, re
from  defs import *
import curses
from curses import panel
import ui
from ui import *
from reports import *
from operin import *
from operout import *
from support import *
from services import *

from  MySQLdb import *
from time import gmtime, strftime, localtime

VER = "0.90-2"

class Store:
    def __init__ (self, win):
	#self.user = get_user()
	self.user = USER
	self.upwd = "none"
	self.userid = 0
	self.set_colors()
	self.win = win
	
	self.SCREEN_LOCKED = FALSE
	self.QUIT_STATUS = FALSE
	
	#    , 
	#      
	#  
	#    ,      
	# ;
	
	#db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	#curs = db.cursor()	
	#curs.execute("""UPDATE documents SET counter=counter+1 WHERE doc_no=199""")
	#curs.execute("""SELECT  counter FROM documents WHERE doc_no=199""")
	#(self.userid, ) = curs.fetchone()
	#db.close()
	self.userid = getuserid()
		
	self.DrawUI()
	self.mainloop()
	
    def DrawUI(self):
	self.main_panel = Panel(0, 0,
		 curses.LINES, curses.COLS, COL_MAIN)
	self.main_panel.drawbox()
	
	#     db        
	#   
	# !  ver 1.2 stable
	
	self.main_panel.set_caption(" COMPANY xxx ")
	self.main_panel.writexy(54, 1,
	         "      ", COL_TITLE, TRUE)
	self.main_panel.hline(1, 3, 50, COL_MAIN)
	self.main_panel.writexy(3, 2, ":", COL_MAIN)
	self.main_panel.writexy(3, 3, str(self.user), COL_MAIN)
	#+ "    :", COL_MAIN)

	self.DrawLOGO()
	self.main_panel.writexy(65, 2, "ver " + VER, COL_MAIN)
	
	self.menu = MenuBar(4, 21, 2, 72, COL_TEXT)

	self.menu.loadMenu("store.mnu")
	curses.curs_set(0)
	pflush()
	
    def DrawLOGO(self):
	self.main_panel.drawrect(4, 3, 75, 16, COL_TAB)
	self.main_panel.hline(5, 4, 51, COL_TAB)
	self.main_panel.win.addch(5, 55, curses.ACS_URCORNER)
	self.main_panel.hline(6, 4, 54, COL_TAB)

	self.main_panel.vline(6, 55, 14, COL_TAB)
	self.main_panel.vline(5, 57, 15, COL_TAB)	
	self.main_panel.vline(5, 53, 15, COL_TAB)		
	
	
	titlestr = "COMPANY xxxx"
	for i in range(6, 17):
	    self.main_panel.writexy(60, i, titlestr[i-6], COL_MAIN)
	self.main_panel.writexy(72, 18, ":", COL_MAIN)
	self.main_panel.writexy(60, 19, " ", COL_MAIN)
	self.main_panel.writexy(5, 20, "Linux OS", COL_MAIN)
	
	
    def set_colors(self):
	if curses.can_change_color() == 1:
	    curses.init_color(5, 800, 800, 800)
	curses.init_pair(1, curses.COLOR_BLUE, curses.COLOR_WHITE)
	curses.init_pair(2, curses.COLOR_WHITE, curses.COLOR_BLUE)
	curses.init_pair(3, curses.COLOR_WHITE, curses.COLOR_RED)
	curses.init_pair(4, curses.COLOR_WHITE, curses.COLOR_BLACK)
	curses.init_pair(5, curses.COLOR_BLACK, curses.COLOR_WHITE)
	curses.init_pair(6, curses.COLOR_RED, curses.COLOR_WHITE)
	curses.init_pair(7, curses.COLOR_BLUE, curses.COLOR_BLACK)
	curses.init_pair(8, curses.COLOR_MAGENTA, curses.COLOR_WHITE)

    def ForceQuit(self):
	return FALSE
	
    def ScreenLocked(self):
	return FALSE
    
    def mainloop(self):
	while 1:
	    cmd = self.menu.mainLoop()
	    if cmd == "cmd_stop": break
	    if cmd == "cmd_insert_request":
		(customer, dan_no) = self.SelectPartner(2, object = 2)
		if customer <> None and dan_no <> None:
		    #raznos = self.whatDocument(customer, dan_no)
		    (raznos_no, raznos_name) = self.SelectDocument("")
		    counter = getDoc_counter(doc_no = raznos_no)
		    saledlg = SalesDialog(self.userid, customer, dan_no, raznos_no, raznos_name, counter, _request = TRUE)
		    status = saledlg.mainLoop()
			
		    saledlg.destroy()
		    del saledlg
		    pflush()
		
	    if cmd == "cmd_insert_out_new":
		(customer, dan_no) = self.SelectPartner(2, object = 2)
		if customer <> None and dan_no <> None:
		    #raznos = self.whatDocument(customer, dan_no)
		    (raznos_no, raznos_name) = self.SelectDocument("")
		    counter = getDoc_counter(doc_no = raznos_no)
		    saledlg = SalesDialog(self.userid, customer, dan_no, raznos_no, raznos_name, counter)
		    status = saledlg.mainLoop()
			
		    saledlg.destroy()
		    del saledlg
		    pflush()
		    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
		    curs = db.cursor()	
		    curs.execute("""DELETE FROM reserve WHERE
				operid = %s""",
				(self.userid, ))
		    db.close()
		    
	    if cmd == "cmd_insert_out_palet":
		(customer, dan_no) = self.SelectPartner(2, object = 2)
		if customer <> None and dan_no <> None:
		    #raznos = self.whatDocument(customer, dan_no)
		    (raznos_no, raznos_name) = self.SelectDocument("")
		    counter = getDoc_counter(doc_no = raznos_no)
		    saledlg = SalesDialog(self.userid, customer, dan_no, raznos_no, raznos_name, counter, _palet = 1)
		    status = saledlg.mainLoop()
			
		    saledlg.destroy()
		    del saledlg
		    pflush()
		    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
		    curs = db.cursor()	
		    curs.execute("""DELETE FROM reserve WHERE
				operid = %s""",
				(self.userid, ))
		    db.close()

	    if cmd == "cmd_materiali":
		dd = ShiftIndx(self)
		status = dd.mainLoop()
		if status <> ev_FAIL:
		    _shift = int(dd.shift.text)
		    _date = dd.nowday.text
		    _si = _date[6:8] + _date[3:5] + _date[0:2]
		    _shift_indx = int(_si)
		    
		    dd.destroy()
		    del dd
		    pflush()
		    
		    customer = PROIZV_NAME + "-  " + str(_shift) + "  " + _date
		    dan_no = PROIZV_DNOM
		    #(raznos_no, raznos_name) = self.SelectDocument("")
		    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
		    curs = db.cursor()	
		    curs.execute("""SELECT doc_no, name FROM documents WHERE doc_no = 202""")
		    (raznos_no, raznos_name) = curs.fetchone()
		    db.close()
		    counter = getDoc_counter(doc_no = raznos_no)
		    saledlg = SalesDialog(self.userid, customer, dan_no, raznos_no, raznos_name, counter, fixobjects = 4, shift = _shift, shift_indx = _shift_indx)
		    status = saledlg.mainLoop()
			
		    saledlg.destroy()
		    del saledlg
		    pflush()
		    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
		    curs = db.cursor()	
		    curs.execute("""DELETE FROM reserve WHERE
				     operid = %s""",
				     (self.userid, ))
		    db.close()
		else:
		    dd.destroy()
		    del dd
		pflush()
		

		    
	    if cmd == "cmd_product":
		dd = ShiftIndx(self)
		status = dd.mainLoop()
		if status <> ev_FAIL:
		    _shift = int(dd.shift.text)
		    _date = dd.nowday.text
		    _si = _date[6:8] + _date[3:5] + _date[0:2]
		    _shift_indx = int(_si)
		    
		    dd.destroy()
		    del dd
		    pflush()
		    
		    proizv = ProizvProd(self, _shift, _shift_indx)
		    proizv.mainLoop()
		    proizv.destroy()
		    del proizv
		    pflush()
		else:
		    dd.destroy()
		    del dd
		pflush()
	    
		    
	    if cmd == "cmd_surowini":
		dd = ShiftIndx(self)
		status = dd.mainLoop()
		if status <> ev_FAIL:
		    _shift = int(dd.shift.text)
		    _date = dd.nowday.text
		    _si = _date[6:8] + _date[3:5] + _date[0:2]
		    _shift_indx = int(_si)
		    
		    dd.destroy()
		    del dd
		    pflush()
		    
		    customer = PROIZV_NAME + "-  " + str(_shift) + "  " + _date
		    dan_no = PROIZV_DNOM
		    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
		    curs = db.cursor()	
		    #    2  -   
		    #    4  -    
		    curs.execute("""SELECT doc_no, name FROM documents WHERE doc_no = 23""")
		    (raznos_no, raznos_name) = curs.fetchone()
		    curs.execute("""SELECT doc_no, name FROM documents WHERE doc_no = 201""")
		    (altno, altname) = curs.fetchone()
		    counter = getDoc_counter(doc_no = raznos_no)
		    db.close()
		    saledlg = SalesDialog(self.userid, customer, dan_no, raznos_no, raznos_name, counter, fixobjects = 24, shift = _shift, shift_indx = _shift_indx, alt_raznos_name = altname)
		    status = saledlg.mainLoop()
			
		    saledlg.destroy()
		    del saledlg
		    pflush()
		    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
		    curs = db.cursor()	
		    curs.execute("""DELETE FROM reserve WHERE
				     operid = %s""",
				     (self.userid, ))
		    db.close()
		else:
		    dd.destroy()
		    del dd
		pflush()
		
		
		    
	    if cmd == "cmd_insert_in_new":
		(obj_no, obj_name) = self.SelectObject()
		(partner, dan_no) = self.SelectPartner(1, object = obj_no)
		if partner <> None and dan_no <> None:
		    #           ????
		    (no, name) = self.SelectDocument("")
		    counter = getDoc_counter(doc_no = no, oper = "")
		    ddlg = DeliveryDialog(obj_no, obj_name, partner, dan_no, no, name, counter)
		    ddlg.mainLoop()
		    ddlg.destroy()
		    del ddlg
		    pflush()
		
	    if cmd == "cmd_insert_delivery_future":
		(partner, dan_no) = self.SelectPartner(1)
		#           ????
		(no, name) = self.SelectDocument("")
		(obj_no, obj_name) = self.SelectObject()
		counter = getDoc_counter(doc_no = no, oper = "")
		ddlg = DeliveryDialog(obj_no, obj_name, partner, dan_no, no, name, counter, future = 0)
		ddlg.mainLoop()
		ddlg.destroy()
		del ddlg
		pflush()
	    
	    if cmd == "cmd_store_list":
		(obj_no, obj_name) = self.SelectObject()
		storelist = AvailableArts(obj_no, obj_name)
		storelist.mainLoop()
		storelist.destroy()
		del storelist
		pflush()

	    if cmd == "cmd_list_arts_in":
		(obj_no, obj_name) = self.SelectObject()
		storelist = ListArtsIn(obj_no, obj_name)
		storelist.mainLoop()
		storelist.destroy()
		del storelist
		pflush()
		
	    if cmd == "cmd_total_out":
		params = RekapParams()
		params.mainLoop()
		params.destroy()
		del params
		pflush()
		
	    if cmd == "cmd_total_in":
		params = RekapParams(_doctype = "")
		params.mainLoop()
		params.destroy()
		del params
		pflush()
		
	    if cmd == "cmd_exped":
		datedlg = DateDialog()
		(status, date) = datedlg.mainLoop()
		datedlg.destroy()
		del datedlg
		pflush()
		if status == ev_OK:
		    catalog = ExpedCatalog(date)
		    catalog.mainLoop()
		    catalog.destroy()
		    del catalog
		    pflush()
		    
	    if cmd == "cmd_customers":
		cl = AddCustomer(loadfn = 0)
		cl.mainLoop()
		cl.destroy()
		del cl
		pflush()

	    if cmd == "cmd_articles_group":
		(obj_no, obj_name) = self.SelectObject()
		cl = AddArticle(object_no = obj_no, object_name = obj_name)
		cl.mainLoop()
		cl.destroy()
		del cl
		pflush()
		
	    if cmd == "cmd_objects":
		obdlg = CreateObject()
		obdlg.mainLoop()
		obdlg.destroy()
		del obdlg
		pflush()
		
		
	    
				
    def SelectDocument(self, doc_type):
	docdlg = DocumentDialog(doc_type)
	(doc_no, name) = docdlg.mainLoop()
	docdlg.destroy()
	del docdlg
	pflush()
	return (doc_no, name)
    
    def SelectObject(self):
	objdlg = ObjectDialog()
	(obj_no, obj_name) = objdlg.mainLoop()
	objdlg.destroy()
	del objdlg
	pflush()
	return (obj_no, obj_name)    
		
    def SelectPartner(self, partner_type, object = None):
	partdlg = PartnersDialog(partner_type, object)
	(dan_no, city, partner_name) = partdlg.mainLoop()
	partdlg.destroy()
	del partdlg
	if dan_no == None and city == None and partner_name == None:
	    return (None, None)
	else:
	    return (strip(partner_name) + " - " + strip(city), strip(dan_no))

#class ObjectBox(DropDnBox):
#    def 



	
if __name__ == '__main__':
    
    def RunProgram(stdscreen):
	app = Store(stdscreen)
	
	
    str = curses.wrapper(RunProgram)
    print str	
    
