#!/usr/bin/env python

import os, string
from  defs import *
import curses
from curses import panel
import ui
from ui import *
from  MySQLdb import *
from time import gmtime, strftime
import threading


info_rq  = 1
info_in  = 2
info_out = 3

info_common = 20


def get_user():
    import pwd
    return pwd.getpwuid(os.getuid())[4]

class Sales:
    def __init__ (self, win):
	self.user = get_user()
	self.set_colors()
	self.win = win
	self.DrawUI()

	self.in_menu = FALSE
	
#	self.ScreenLock = threading.Lock()
	
#	self.rq_handler = RequestsHandler(self)
#	self.rq_handler.setInterval(60)
#	self.rq_handler.start()
	
#	self.in_handler = DeliveriesHandler(self)
#	self.in_handler.setInterval(120)
#	self.in_handler.start()
	
	self.mainloop()
	
    def DrawUI(self):
	self.main_panel = Panel(0, 0,
		 curses.LINES, curses.COLS, COL_MAIN)
	self.main_panel.drawbox()
	self.main_panel.set_caption(" COMPANY XXX ")
	self.main_panel.writexy(50, 1,
	         "     - ", COL_TITLE, TRUE)
	self.main_panel.hline(1, 3, 46, COL_MAIN)
	self.main_panel.writexy(3, 2, ":", COL_MAIN)
	self.main_panel.writexy(3, 3, str(self.user), COL_MAIN)
#	+ "    :", COL_MAIN)

	self.DrawLOGO()
	
	self.menu = MenuBar(4, 21, 2, 22, COL_TEXT)

	self.menu.loadMenu("sx.mnu")
	curses.curs_set(0)
	pflush()
	
    def DrawLOGO(self):
	self.main_panel.drawrect(4, 3, 75, 16, COL_TAB)
	self.main_panel.hline(5, 4, 51, COL_TAB)
	self.main_panel.win.addch(5, 55, curses.ACS_URCORNER)
	self.main_panel.hline(6, 4, 54, COL_TAB)

	self.main_panel.vline(6, 55, 14, COL_TAB)
	self.main_panel.vline(5, 57, 15, COL_TAB)	
	self.main_panel.vline(5, 53, 15, COL_TAB)		
	
	
	titlestr = "COMPANY xxx"
	for i in range(6, 16):
	    self.main_panel.writexy(60, i, titlestr[i-6], COL_MAIN)
	self.main_panel.writexy(72, 18, ":", COL_MAIN)
	self.main_panel.writexy(60, 19, " ", COL_MAIN)
	self.main_panel.writexy(5, 20, "Linux OS", COL_MAIN)
	
	self.main_panel.writexy(30, 21, " ", COL_WARN)
	self.main_panel.writexy(45, 21, " ", COL_WARN)	
	
	
    def set_colors(self):
	if curses.can_change_color() == 1:
	    curses.init_color(5, 800, 800, 800)
	curses.init_pair(1, curses.COLOR_BLUE, curses.COLOR_WHITE)
	curses.init_pair(2, curses.COLOR_WHITE, curses.COLOR_BLUE)
	curses.init_pair(3, curses.COLOR_WHITE, curses.COLOR_RED)
	curses.init_pair(4, curses.COLOR_WHITE, curses.COLOR_BLACK)
	curses.init_pair(5, curses.COLOR_BLACK, curses.COLOR_WHITE)
	curses.init_pair(6, curses.COLOR_RED, curses.COLOR_WHITE)
	curses.init_pair(7, curses.COLOR_BLUE, curses.COLOR_BLACK)
	curses.init_pair(8, curses.COLOR_MAGENTA, curses.COLOR_WHITE)

	
    def ShowInfo(self, info_type, msg):
	if self.in_menu == TRUE: return
	if info_type == info_rq:
	    self.ScreenLock.acquire()
	    s = center(msg, 13)
	    self.main_panel.writexy(30, 22, s, COL_WARN)
	    pflush()
	    self.ScreenLock.release()
	    
	if info_type == info_in:
	    self.ScreenLock.acquire()
	    s = center(msg, 14)
	    self.main_panel.writexy(45, 22, s, COL_WARN)
	    pflush()
	    self.ScreenLock.release()	    
	    
	if info_type == info_common:
	    self.ScreenLock.acquire()
	    self.main_panel.writexy(60, 22, msg, COL_WARN)
	    pflush()
	    self.ScreenLock.release()
	    
	
    def mainloop(self):
	while 1:
	    cmd = self.menu.mainLoop()
	    if cmd == "cmd_exit": self.win.getch()
	    if cms == "cmd_future_in":
		pass
		
	    if cmd == "cmd_insert_request":
		(customer, dan_no) = self.SelectCustomer(2)
		counter = self.getDoc_counter(doc_no = 70)
		rqdlg = RequestDialog(customer, dan_no, counter)
		rqdlg.mainLoop()
		rqdlg.destroy()
		del rqdlg
		pflush()
	    if cmd == "cmd_stop":
		#self.rq_handler.shutdown()
		#self.in_handler.shutdown()
		break
		

    def getDoc_counter(self, doc_no = None, doc_name = ""):
	if doc_no <> None:
	    query = " WHERE doc_no = " + str(doc_no)
	    if doc_name <> "":
		query = query + " AND doc_name = " + doc_name
	else:
	    query = " WHERE doc_name = " + doc_name
	db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	curs = db.cursor()
	curs.execute("UPDATE LOW_PRIORITY documents SET counter=counter+1" + query)
	curs.execute("SELECT CONCAT(counter, '') from documents" + query)
	(counter, ) = curs.fetchone()
	db.commit()
	db.close()
	return counter
	
	
		
		
    def SelectCustomer(self, customer_type):
	custdlg = CustomerDialog(customer_type)
	(dan_no, city, customer_name) = custdlg.mainLoop()
	custdlg.destroy()
	del custdlg
	return (strip(customer_name) + " - " + strip(city), strip(dan_no))

    
class DocList(MultiListBox):
    def dbLoad(self):
	recs = self.curs.fetchmany(200)
	self.db.commit()
	self.db.close()
	l = len(recs)
	ncols = self.getColonsNumber()
	for i in range(l):
	    it = []
	    for j in range(ncols):
		it.append(str(recs[i][j]))
	    self.addItem(it, ????????????????? hidden=str(recs[i][ncols+1:len(recs[i]))
	self.lastSearch = 0
	return l	
    

class StockDialog(Dialog):
    def __init__(self):
	
	#self.dbquery = ""
	
	Dialog.__init__(self, 2, 4, 18, 76, COL_MAIN)
	#self.set_caption()
	self.alist = MultiListBox(self, 2, 2, 10, 70, COL_TEXT)
	self.alist.MultipleChoice(FALSE)
	
	self.alist.setItemColors(COL_TITLE, COL_TEXT)
	self.alist.Focusable = TRUE
	self.alist.delPermitted = FALSE
	self.alist.Numerate(3)
	self.alist.addColon(8, "")
	self.list.addColon(32, "")
	self.list.addColon(8, "")
	self.list.addColon(10, "")	
	self.list.addColon(10, ".")
	self.list.Update()
	#0
	self.addWidget(self.list)	
	
class FutureDelivery(StockDialog):
    def __init__(self):
	StockDialog.__init__(self)
	self.set_caption(" ")
	self.query = "SELECT CONCAT(group_no, art_no), name, qty_id, deliv_qnty, deliv_qnty/pack1
	m = Message()
	
	
    
class DocumentsHandler(threading.Thread):
    def __init__(self, Screen):
	threading.Thread.__init__(self)
	self._finished = threading.Event()
	self._interval = 300
	self.scr = Screen
	self.docrecs = []
	self.row = 0
	
	self.Query = ""
	self.Condition = ""
	self.database = ""
	self.datatable = ""
	
	self.db = None
	self.curs = None

	
    def dbConnect(self):
	self.db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	self.curs = self.db.cursor()
	
    def setQuery(self, query):
	self.Query = query
	
    def setCondition(self, condition):
	self.Condition = condition
	
    def setDataBase(self, dbase):
	self.database = dbase
	
    def setTable(self, table):
	self.datatable = table
	
    def getRow(self, indx):
	if indx < len(self.docrecs):
	    return self.docrecs[indx]
	else:
	    return None
    
    def nextRow(self):
	if self.row < len(self.docrecs):
	    self.row = self.row + 1
	    return self.docrecs[self.row]
	else:
	    return None

    def getDocumentsCount(self):
	pass
    
    def PrintDocument(self):
	pass

    def setInterval(self, interval):
	self._interval = interval
    
    def shutdown(self):
	self._finished.set()
	
    def run(self):
	while 1:
	    if self._finished.isSet():
		return
	    self.task()
	    self._finished.wait(self._interval)
	    
    def task(self):
	pass
	
    
class RequestsHandler(DocumentsHandler):
    def __init__(self, Screen):
	DocumentsHandler.__init__(self, Screen)
	self.database = "eso"
	self.datatable = "requests"	
	
	self.request = []
	
    def task(self):
	self.dbConnect()
	nd = self.curs.execute("SELECT min(counter) FROM requests WHERE forced < 100 GROUP by counter")
	(mincounter, ) = self.curs.fetchone()
	#self.db.close()
	self.row = self.row+1
	if mincounter == None and nd == 1:
	    self.scr.ShowInfo(info_rq, "")
	else:
	    self.scr.ShowInfo(info_rq, str(nd))
	    self.curs.execute("""SELECT counter,
	                            dan_no,
	                            group_no, art_no,
				    object_id, 
				    tweight, pack, tpacks,
				    price 
				    FROM requests WHERE
				    counter = %s AND 
				    forced < 100""", (mincounter,))
	    self.request = self.curs.fetchall()
	    self.scr.ShowInfo(info_common, str(mincounter))
	    for i in range(len(self.request)):
		rl = self.request[i]
		grc = rl[2]
		arc = rl[3]
		obj = rl[4]
		tweight = rl[5]
		price = rl[8]
		#self.scr.ShowInfo(info_common, str(grc)+str(arc)+str(tweight))
		#if i == 0:
		#    #db.close()
		#    break
		self.curs.execute("""SELECT rest_qnty,
					    doc_no, doc_counter,
					    doc_date, 
					    partn_dn FROM delivery
					    WHERE
					    group_no = %s AND
					    art_no = %s AND
					    object_no = %s AND
					    rest_qnty > 0 AND 
					    valid = 1 ORDER BY doc_date""",
					    (grc, arc, obj))
		deliv = self.curs.fetchall()
		self.scr.ShowInfo(info_common, str(deliv[0][0]) + " - " + str(tweight))
		#if i == 1:
		#    break
		for j in range(len(deliv)):
		    d1 = deliv[j]
		    #self.scr.ShowInfo(info_common, str(d1[0]) + " - " + str(tweight))
		    if tweight == 0:
			break
		    if d1[0] < tweight:
			#    = 0
			tweight = tweight - d1[0]
			self.curs.execute("""UPDATE delivery SET
					rest_qnty = 0 WHERE
					group_no = %s AND
					art_no = %s AND
					object_no = %s AND
					doc_no = %s AND
					doc_counter = %s AND
					doc_date = %s AND
					partn_dn = %s AND
					valid = 1""",
					(grc, arc, obj,
					d1[1], d1[2], d1[3], d1[4]))
		    else:
			#
			#rest_qnty = rest_qnty - tweight
			self.curs.execute("""UPDATE delivery SET
					rest_qnty = rest_qnty - %s WHERE
					group_no = %s AND
					art_no = %s AND
					object_no = %s AND
					doc_no = %s AND
					doc_counter = %s AND
					doc_date = %s AND
					partn_dn = %s AND
					valid = 1""",
					(tweight, grc, arc, obj,
					d1[1], d1[2], d1[3], d1[4]))			
			tweight = 0
		    
		self.curs.execute("""UPDATE requests SET
				     forced = 200 WHERE
				     counter = %s AND
				     group_no = %s AND
				     art_no = %s AND
				     object_id = %s""",
				     (mincounter, grc, arc, obj))
				     
				     
				     
		    
			    
					    
	    self.shutdown()
	self.db.close()
	

class DeliveriesHandler(DocumentsHandler):
    def __init__(self, Screen):
	DocumentsHandler.__init__(self, Screen)
	self.database = "eso"
	self.datatable = "delivery"
	
    def task(self):
	self.dbConnect()
	nd = self.curs.execute("SELECT min(doc_counter) from delivery WHERE valid = 0 and rest_qnty != 0 GROUP by doc_counter")
	(mincounter, ) = self.curs.fetchone()
	self.db.close()
	if mincounter == None and nd == 1:
	    self.scr.ShowInfo(info_in, "")
	else:
	    self.scr.ShowInfo(info_in, str(nd))
	
	
	

if __name__ == '__main__':
    def RunProgram(stdscreen):
	app = Sales(stdscreen)
	
	
    str = curses.wrapper(RunProgram)
    print str	
