#!/usr/bin/env python

import  MySQLdb

db = MySQLdb.connect(user="cv", passwd="cv", db="eso")
c = db.cursor()

c.execute("""CREATE TABLE delivery (
	     base	  tinyint not null default 1,
	     rid	  int unsigned auto_increment,
             group_no     int(3) zerofill not null,
	     art_no	  int(3) zerofill not null,
	     
	     object_no    int unsigned not null,
	     
	     partn_dn     varchar(10) not null,
	     
	     doc_no       int unsigned not null, 
	     doc_counter  int(10) zerofill not null default '0000000000',
	     doc_date     date not null,
	     
	     deliv_qnty   decimal(9,2) not null, 
	     price	  decimal(10,4) not null, 
	     rest_qnty    decimal(9,2) not null,
	    
	     valid        tinyint not null,
	     valid_date   datetime not null,
	     valid_oper   char(32) not null default '',
	     
	     source_ty    int unsigned not null default 0,
	     source_no    int(10) zerofill not null default '0000000000',
	     source_rid   int unsigned not null default 0,
	     
	     archive	  tinyint not null default 0,
	     
	     date         datetime not null,
	     oper         char(32) not null default '',
	     primary key (base, object_no, rid))

          """)
	  
c.close()
c=db.cursor()

c.execute("""CREATE TABLE tempdeliv (
             name         char(32) not null,
	     partn_dn     varchar(10) not null,
	     
	     doc_no       int unsigned not null, 
	     doc_counter  int(10) zerofill not null default '0000000000',
	     doc_date     date not null)
          """)
	  
	  
db.close()
print "Ok"
	  
