#!/usr/bin/env python

import  MySQLdb

db = MySQLdb.connect(user="cv", passwd="cv", db="eso")
c = db.cursor()

c.execute("""CREATE TABLE requests (
             object_no   tinyint not null default 2,
	     
             artid       int(5) zerofill not null,	     
	     artname     char(32) binary not null,
	     qnty_id     char(12) not null,
	     
	     tweight     decimal(10,3) not null, 
	     tpacks      decimal(10,3) not null,
	     qnty        decimal(10,3) not null,
	     price       decimal(9,4) not null,
	     
	     rcd_price   decimal(9,4) not null,
	     pack        mediumint not null,	     
	     	     
             counter     int(10) unsigned zerofill not null,
	     lineindx    tinyint not null,
	     doc_no      int unsigned not null,
	     doc_date    date not null,
	     
	     dan_no      varchar(10) not null,
	     presenter   char(32) not null default '',
	     exped_no    int unsigned not null default 0,
	     
	     fin_date    datetime not null,
	     forced      tinyint unsigned default 0,
	     ready       tinyint not null default 0,
	     
	     date        datetime not null,
	     oper        char(32) not null default '', 
	     primary key (counter, lineindx))
	     """)
db.close()
print "Ok"
	     
	     
	     
