import os, re
from  defs import *
import curses
from curses import panel
import ui
from ui import *
from support import *
from reports import *
from  MySQLdb import *
from time import gmtime, strftime, localtime

		
#-----------------------------------------------------------------------------
#    

class SalesDialog(Dialog):
    def __init__(self, userid, customer_name, dan_no, raznos_no, raznos_name, counter, fixobjects = 1, _request = FALSE, _presenter = None, _palet = 0, shift = None, shift_indx = None, alt_raznos_name = None):
	self.userid = userid

	self.shift = shift
	self.shift_indx = shift_indx
	self.alt_raznos_name = alt_raznos_name
	
	self.request = _request
	self.presenter = _presenter
	self.palet = _palet
	self._fixobjects = fixobjects
	
	self.nowday = strftime("%d/%m/%y", gmtime())
	self.finalDate = self.nowday
	self.object_id = []         

	self.rq_total_weight = 0
	self.rq_total_pack = 0
	self.rq_total_price = 0
	self.raznos_no = raznos_no
	self.raznos_name = raznos_name
	self.docCounter = counter       #     
	self.transferCounter = 0
	self.object_changed = FALSE 	#       __init__
	self.Customer = customer_name
	self.Customer_dan_no = dan_no
	
	self.reqindx = -1
	
	Dialog.__init__(self, 0, 0, 24,  79, COL_MAIN)
	if self._fixobjects == 1:
	    if self.palet == 0:
		self.set_caption(" - " + strip(raznos_name))
	    else:
		self.set_caption(" - " + strip(raznos_name) + " -   ")
	elif self._fixobjects == 24:
	    self.set_caption("   - " + raznos_name)
	elif self._fixobjects == 4:
	    self.set_caption("   ")
	    #   
	    self.writexy(67, 0, "    : " + str(self.shift) + " ", COL_WARN)
	    self.writexy(54, 0, "  : " + str(self.shift_indx) + " ", COL_WARN)
		
	#0
	self.addWidget(Label(self, 3, 1, " :", COL_TEXT1))
	self.objectBox = ObjectBox(self, 16, 1, 18, 6, COL_TEXT1, loadfn = self._fixobjects)
	#1
	self.addWidget(self.objectBox)
	self.current_object = self.getObject_no(self.objectBox.text)
	
	self.artlist = MultiListBox(self, 1, 17, 6, 77, COL_TEXT)
	self.artlist.MultipleChoice(FALSE)
	self.artlist.setItemColors(COL_TITLE, COL_TEXT)
	self.artlist.Focusable = TRUE
	self.artlist.dbQuery = "SELECT CONCAT(articles.group_no, articles.art_no), articles.name, articles.qty_id, articles.weight, articles.pack1, sum(delivery.rest_qnty) FROM articles, delivery WHERE delivery.object_no = " + str(self.current_object) + " AND articles.object_no = delivery.object_no AND articles.group_no = delivery.group_no AND articles.art_no = delivery.art_no AND delivery.valid = 1 AND delivery.rest_qnty > 0 GROUP by 1 ORDER BY articles.name"
	self.artlist.addColon(6, ".")
	self.artlist.addColon(31, "")
	self.artlist.addColon(5, "/")
	self.artlist.addColon(6, ".")
	self.artlist.addColon(6, ".")	
	self.artlist.addColon(10, "")
	m = Message()
	m.message = cm_RELOAD
	self.artlist.Update(m)	
	
	#2
	self.addWidget(Label(self, 3, 2, ". :", COL_TEXT1))
	#3
	self.addWidget(Label(self, 60, 2, ".", COL_TEXT1))
	#4
	#self.addWidget(Label(self, 44, 1, "", COL_TEXT1))
	self.set_color(COL_MAIN)
	#self.win.hline(3, 1, curses.ACS_BSSB, 78, 5)
	self.win.hline(13, 1, curses.ACS_BSSB, 78, 5)	
	#5
	#self.addWidget(Label(self, 50, 1, self.finalDate, COL_TEXT))
	#4
	self.addWidget(Label(self, 60, 1, "", COL_TEXT1))
	self.edate = DateLine(self, 68, 1, COL_TEXT, COL_TITLE)
	self.edate.SetText(self.finalDate)
	#5
	self.addWidget(self.edate)
	
	#6
	self.addWidget(Label(self, 2, 14, "/.", COL_TEXT1))
	self.arttxt = EditLine(self, 2, 15, 20, COL_WARN, COL_WARN)
	self.arttxt.SetText(" ")
	self.arttxt.Focusable = FALSE
	#7
	self.addWidget(Label(self, 25, 14, ".", COL_TEXT1))	
	self.single = EditLine(self, 25,  15, 9, COL_TEXT, COL_TITLE)	
	self.single.setType(dt_numeric)
	#8
	self.addWidget(Label(self, 66, 14, ".", COL_TEXT1))
	self.artweight = EditLine(self, 66,  15, 4, COL_TEXT, COL_TITLE)
	self.artweight.Focusable = FALSE
	#9
	self.addWidget(Label(self, 45, 14, "", COL_TEXT1))
	self.totalweight = EditLine(self, 45,  15, 9, COL_TEXT, COL_TITLE)
	self.totalweight.setType(dt_float)
	#10
	self.addWidget(Label(self, 72, 14, "/", COL_TEXT1))	
	self.artpack = EditLine(self, 72,  15, 5,  COL_TEXT, COL_TITLE)	
	self.artpack.Focusable = FALSE
	#11
	self.addWidget(Label(self, 36, 14, ".", COL_TEXT1))	
	self.totalpack = EditLine(self, 36,  15, 7, COL_TEXT, COL_TITLE)	
	self.totalpack.setType(dt_numeric)

	#12	
	self.addWidget(Label(self, 56, 14, ".", COL_TEXT1))	
	self.artprice = EditLine(self, 56,  15, 8, COL_TEXT, COL_TITLE)	
	self.artprice.setType(dt_float)
	#13
	self.addWidget(self.arttxt)
	#14
	self.addWidget(self.single)
	#15
	self.addWidget(self.totalpack)
	#16
	self.addWidget(self.totalweight)	
	#17
	self.addWidget(self.artprice)	
	#18
	self.addWidget(self.artweight)
	#19
	self.addWidget(self.artpack)	
	
	#20
	self.addWidget(self.artlist)
	
	self.reqlist = MultiListBox(self, 1, 3, 8, 77, COL_TEXT)
	self.reqlist.MultipleChoice(FALSE)
	self.reqlist.setItemColors(COL_TITLE, COL_TEXT)
	self.reqlist.Focusable = TRUE
	self.reqlist.delPermitted = TRUE
	self.reqlist.addColon(6, ".")
	self.reqlist.addColon(31, "")
	self.reqlist.addColon(5, "/")
	self.reqlist.addColon(10, "  ", dt_float, 2)
	self.reqlist.addColon(8, "", dt_float, 2)	
	self.reqlist.addColon(10, ".", dt_float, 2)
	self.reqlist.addColon(7, "", dt_float, 3)
	self.reqlist.Update()
	#21
	self.addWidget(self.reqlist)
	#22
	self.addWidget(Label(self, 19, 2, customer_name, COL_MAIN))
	if self._fixobjects == 4:
	    odocno = str(self.shift) + str(self.shift_indx)
	    while len(odocno) < 10:
		odocno = "0" + odocno
	    self.writexy(66, 2, str(odocno), COL_TEXT1)
	else:
	    self.writexy(66, 2, str(counter), COL_TEXT1)
	self.writexy(38, 12, " :", COL_TITLE, bold=TRUE)
	
	self.arttxt.addNotifyRecipient(self.artlist, cm_RELOAD, "\'")	
	self.artlist.addNotifyRecipient(self.artweight, cm_UPDATE, 3)
	self.artlist.addNotifyRecipient(self.artpack, cm_UPDATE, 4)
	#self.artlist.addNotifyRecipient(self.arttxt, cm_UPDATE, 0)
	
	#self.artweight.addNotifyRecipient(self.artlist, cm_LOCATE, 2)
	#self.artpack.addNotifyRecipient(self.artlist, cm_LOCATE, 3)
	
	if self._fixobjects == 1 and self.request == FALSE:
	    self.AddHotKey(curses.KEY_F4, 1)
	
	self.AddHotKey(curses.KEY_F1, 5)
	self.AddHotKey(curses.KEY_F12, 5)	
	self.AddHotKey(curses.KEY_F10, 13)
#	self.AddHotKey(curses.KEY_F8, 15)
	self.AddHotKey(curses.KEY_F6, 21)
	self.writexy(2, 24, " | F1 -  | F4 -  | F6 - . | F10 -  | ", COL_TITLE, bold = TRUE)
	#self.writexy(18, 24, "| F2 -  |", COL_TITLE, bold=TRUE)
	#self.writexy(33, 24, " F6 - . |", COL_TITLE, bold=TRUE)	
	#self.writexy(47, 24, " F4 -  |", COL_TITLE, bold=TRUE)		
	
	self.select(5)

    def mainLoop(self):
	while 1:
	    status = Dialog.mainLoop(self)
	    if status == ev_FAIL and self.quitstatus == 1:
		msgbox = MessageBox(28, 9, 8, 26, COL_TAB, COL_TAB, \
		                        ["  ", "  "], "?", msg_YESNO)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		if yes == cmd_YES:
		    break
		else:
		    self.select(self.control)
		    self.quitstatus = 0
	    if status == ev_OK:
		break
	
	
    def getObject_no(self, name):
	db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host = "192.168.0.2")
	curs = db.cursor()
	if self._fixobjects == 4:
	    curs.execute("""SELECT obj_no FROM objects WHERE objid=%s AND flag = ''""", (name,))
	else:
	    curs.execute("""SELECT obj_no FROM objects WHERE objid=%s AND flag = ''""", (name,))
	(obj_no, ) = curs.fetchone()
	db.close()
	return obj_no
    
    def AddObject(self, object):
	found = FALSE
	for i in range(len(self.object_id)):
	    if self.object_id[i] == object:
		found = TRUE
	if found == FALSE:
	    self.object_id.append(object)
	
    def getPrices(self, code, tpack, tweight, customer = None):
	gr_no = code[0:2]
	art_no = code[2:5]
    	db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	curs = db.cursor()
	#have_offer = curs.execute("""SELECT price1lo, price1hi,
	#                       price2lo, price2hi,
	#		       price3lo, price3hi,
	#		       price4lo, price4hi,
	#		       price5lo, price5hi 
	#		       FROM offers 
	#		       WHERE offer_no = 1 and
	#			     group_no = %s and
	#			     art_no = %s""", (gr_no, art_no))
	#if have_offer > 0:
	#    (p11, p12, p21, p22, p31, p32, p41, p42, p51, p52) = \
	#       curs.fetchone()
	       
	#    db.close()
	#    if tweight <= 25:
	#	return (p11 + p12) / 2
	#    elif tweight > 25 and tweight <= 1000:
	#	return (p21 + p22) / 2
	#    elif tweight > 1000 and tweight <= 3000:
	#	return (p31 + p32) / 2
	#    elif tweight > 3000 and tweight <= 5000:
	#	return (p41 + p42) / 2
	#    elif tweight > 5000:
	#	return (p41 + p42) / 2
	#else:
	#curs.execute("""SELECT max(price) FROM delivery
	#		    WHERE
	#		    group_no = %s AND
	#		    art_no = %s AND
	#		    doc_no IN (3, 6, 12, 23) AND
	#		    rest_qnty > 0 AND
	#		    valid = 1""",
	#		    (gr_no, art_no))
	curs.execute("""SELECT max(price) FROM delivery
			    WHERE
			    group_no = %s AND
			    art_no = %s AND
			    rest_qnty > 0 AND
			    valid = 1""",
			    (gr_no, art_no))
	
	(pp,) = curs.fetchone()
	db.close()
	return pp
	#return 0
    
    def checkQuantity(self, qnty = 1):
	if self.request == TRUE:
	    return qnty
	itno = self.artlist.hilite
	if itno >= 0:
	    #object_no = self.getObject_no(self.objectBox.text)
	    #object_no = self.current_object
	    #self.writexy(20,0,str(object_no),COL_WARN)
	    artcode = self.artlist.items[itno][0].Label
	    grc = artcode[0:2]
	    arc = artcode[2:5]
	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	    curs = db.cursor()
	    #f1 = curs.execute("""SELECT sum(rest_qnty) FROM delivery
	    #                WHERE
	    #		    group_no = %s AND
	    #		    art_no = %s AND
	    #		    doc_no IN (3, 6, 12, 23) AND
	    #		    rest_qnty > 0 AND
	    #		    valid = 1 AND
	    #		    object_no = %s""",
	    #		    (grc, arc, self.current_object))
	    f1 = curs.execute("""SELECT sum(rest_qnty) FROM delivery
	                    WHERE
			    group_no = %s AND
			    art_no = %s AND
			    rest_qnty > 0 AND
			    valid = 1 AND
			    object_no = %s""",
			    (grc, arc, self.current_object))	    
	    if f1 > 0:
		(r1, ) = curs.fetchone()
		#rest = float(r1)
		if r1 == None:
		    r1 = 0
	    else:
		r1 = 0
	    #self.writexy(30,0,str(r1),COL_WARN)
	    f2 = curs.execute("""SELECT sum(qnty) FROM reserve WHERE 
	                         group_no = %s AND
				 art_no = %s AND
				 operid = %s""",
				 (grc, arc, self.userid))
	    if f2 > 0:
		(r2, ) = curs.fetchone()
		if r2 == None:
		    r2 = 0
		#reserve = float(r2)
	    else:
		r2= 0
	    
	    db.close()
	    rest = r1 - r2
	    return rest
	return 0
	

    def createNewDocument(self, cntr):
	pass
        
    def UserFn(self, command, args = None):
	if command == ev_OK:
	    if args == 21:
		self.arttxt.SetText(" ")
		self.select(20)
		return ev_NONE
	    if args == 5:
		self.select(20)
		return ev_NONE
	    if args == 20:
		if self.checkQuantity() > 0:
		    self.single.SetText("")
		    self.totalweight.SetText("")
		    self.totalpack.SetText("") 
		    self.artprice.SetText("") 		    
		    wid = strip(self.artlist.items[self.artlist.hilite][2].Label)
		    
		    if wid == "" or wid == ".":
			self.select(16)
		    else:
			self.select(14)
		else:
		    msgbox = MessageBox(28, 9, 7, 22, COL_TAB, COL_TAB, \
		                        ["  "," "], "", msg_OK)
		    msgbox.mainLoop()
		    msgbox.destroy()
		    del msgbox
		    pflush()		    
		    self.select(20)
		return ev_NONE
	    if args == 14:
		if self.single.text == "":
		    self.select(15)
		    return
		edbr = int(self.single.text)
		weight = float(self.artweight.text)
		if weight == 0: weight = 0.1
		pack = int(self.artpack.text)
		if pack == 0: pack = 1
		if self.checkQuantity(qnty = float(edbr)) - float(edbr) < 0:
		    msgbox = MessageBox(28, 9, 7, 22, COL_TAB, COL_TAB, \
		                        ["  "," "], "", msg_OK)
		    msgbox.mainLoop()
		    msgbox.destroy()
		    del msgbox
		    pflush()		    
		    self.select(14)
		    return ev_NONE
		
		wid = self.artlist.items[self.artlist.hilite][2].Label
		totalweight = edbr * weight
		self.totalweight.SetText(str(totalweight))
		totalpack = float(float(edbr) / float(pack))
		self.totalpack.SetText(fix(totalpack,2))
		ac = self.artlist.items[self.artlist.hilite][0].Label		
		price = self.getPrices(ac, totalpack, totalweight)
		self.artprice.SetText(fix(price,3))
		
		self.select(17)
		return 
	    if args ==  21:
		return ev_DONE
	    if args == 16 and self.totalweight.text <> "": #
		weight = float(self.artweight.text)
		if weight == 0: weight = 0.1
		pack = int(self.artpack.text)
		if pack == 0: pack = 1
		wid = strip(self.artlist.items[self.artlist.hilite][2].Label)
		totalweight = float(self.totalweight.text)
		if wid == "." or wid == "":
		    totalpack = round((totalweight / weight) / pack)
		    self.totalpack.SetText(str(totalpack))
		    totalweight = totalpack * pack * weight
		    self.totalweight.SetText(str(totalweight))
		    br = float(totalpack) * pack
		    
		elif wid == "." or wid == "":
		    totalpack = (totalweight / weight) / pack
		    self.totalpack.SetText(str(totalpack))
		    br = float(totalweight)
		    
		br = str(br)
		self.single.SetText(br)
		if self.checkQuantity(qnty = float(br)) - float(br) < 0:
		    msgbox = MessageBox(28, 9, 7, 22, COL_TAB, COL_TAB, \
		                        ["  "," "], "", msg_OK)
		    msgbox.mainLoop()
		    msgbox.destroy()
		    del msgbox
		    pflush()		    
		    self.select(16)
		    return ev_NONE
				
		ac = self.artlist.items[self.artlist.hilite][0].Label
		grc = ac[0:2]
		arc = ac[2:5]
		
		price = self.getPrices(ac, totalpack, totalweight)
		self.artprice.SetText(fix(price, 3))
		#self.nextWidget()
		self.select(17)
		return ev_NONE
	    if args == 15 and self.totalpack.text <> "": #  
		totalpack = float(self.totalpack.text)
		pack = int(self.artpack.text)
		if pack == 0: pack = 1
		weight = float(self.artweight.text)
		if weight == 0: weight = 0.1
		totalweight = str(totalpack * pack * weight)
		self.totalweight.SetText(totalweight)
		self.artprice.SetText("")
		
		wid = strip(self.artlist.items[self.artlist.hilite][2].Label)
		if wid == "." or wid == "":
		    br = float(totalpack) * pack
		elif wid == "." or wid == "":
		    br = float(totalweight)
		    
		br = str(br)
		self.single.SetText(br)
		if self.checkQuantity(qnty = float(br)) - float(br) < 0:
		    msgbox = MessageBox(28, 9, 7, 22, COL_TAB, COL_TAB, \
		                        ["  "," "], "", msg_OK)
		    msgbox.mainLoop()
		    msgbox.destroy()
		    del msgbox
		    pflush()		    
		    self.select(15)
		    return ev_NONE
		ac = self.artlist.items[self.artlist.hilite][0].Label
		price = self.getPrices(ac, totalpack, totalweight)
		self.artprice.SetText(fix(price,3))
		self.select(17)
		return ev_NONE
	    if args == 21:
		self.select(18)
		return ev_NONE
	    if args == 17:
		if self.checkQuantity(qnty = float(self.single.text)) - float(self.single.text) < 0:
		    msgbox = MessageBox(28, 9, 7, 22, COL_TAB, COL_TAB, \
		                        ["  "," "], "", msg_OK)
		    msgbox.mainLoop()
		    msgbox.destroy()
		    del msgbox
		    pflush()		    
		    self.select(15)
		    return ev_NONE
		self.doc_Counter = 0
		self.AddObject(self.current_object) #    
		#self.writexy(66, 2, str(self.docCounter), COL_TEXT1)
		itno = self.artlist.hilite
		if itno >= 0:
		    artcode = self.artlist.items[itno][0].Label
		    art_name = self.artlist.items[itno][1].Label
		    wid = self.artlist.items[itno][2].Label
		    tw = self.totalweight.text
		    tp = self.totalpack.text
		    pr = self.artprice.text
		    artweight = float(self.artweight.text)
		    pr1 = fix(self.getPrices(artcode, float(tp), float(tw)), 3)
		    if pr == "":
			pr = pr1
			
		    if strip(wid) == "." or strip(wid) == "":
		    	br = self.single.text
		    elif strip(wid) == "." or strip(wid) == "":
			br = tw
		    
		    br = str(br)
		    self.single.SetText(br)
		    #     :
		    #., , ,
		    # (), .,   ;
		    #  :
		    # ,  ,   
		    #     
		    
		    self.reqlist.addItem([artcode, art_name, wid, tw, tp, br, pr], hidden = [int(self.artpack.text), pr1, self.current_object, self.docCounter, len(self.reqlist.items)+1, artweight])
		    #self.reqlist.draw()
		    self.reqlist.handleEvent(curses.KEY_END)
		    #self.reqlist.draw()
		    if self.request == FALSE:
			db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
			curs = db.cursor()
			curs.execute("""INSERT INTO reserve (
		                    group_no, art_no,
				    operid, lineno, 
				    qnty,
				    date, oper) VALUES (
				    %s, %s,
				    %s, %s,
				    %s,
				    NOW(), "cv")""",
				    (artcode[0:2], artcode[2:5],
				    self.userid, len(self.reqlist.items),
				    float(br)))
		    
		    sum = float(br) * float(pr)
		    self.rq_total_weight = self.rq_total_weight + float(tw)
		    self.rq_total_pack = self.rq_total_pack + float(tp)
		    self.rq_total_price = self.rq_total_price + sum
		    self.writexy(44, 12, rjust(fix(self.rq_total_weight, 2), 9) + " ", COL_TITLE, bold = TRUE)
		    self.writexy(53, 12, rjust(fix(self.rq_total_pack, 2), 8) + " ", COL_TITLE, bold = TRUE)
		    self.writexy(62, 12, " :", COL_WARN, bold = TRUE)
		    self.writexy(68, 12, rjust(fix(self.rq_total_price,2), 10) + " " , COL_WARN, bold = TRUE)	    
		    self.single.SetText("")
		    self.totalweight.SetText("")            
		    self.totalpack.SetText("") 
		    self.artprice.SetText("") 
		self.select(20)
		return ev_NONE
	    if args == 13:
		if self.artlist.hilite == -1:
		    msgbox = MessageBox(28, 9, 6, 20, COL_TAB, COL_TAB, \
		                        [" ",], "", msg_OK)
		    msgbox.mainLoop()
		    msgbox.destroy()
		    del msgbox
		    pflush()
		    self.select(13)
		    return ev_NONE
		else:
		    self.totalpack.SetText("") 
		    self.totalweight.SetText("") 
		    self.artprice.SetText("") 
		    self.select(20)
		    return ev_NONE
	    else:
		self.nextWidget()
		return ev_NONE
	if command == ev_FAIL:
	    if args == 18:
		self.select(12)
		return ev_NONE
	if command == ev_ACTIVATE and args == curses.KEY_F10:
	    if len(self.reqlist.items) == 0:
		msgbox = MessageBox(28, 9, 8, 25, COL_TAB, COL_TAB, \
	                        ["   !", ""], " !", \
				msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		return ev_DONE
	    msgbox = MessageBox(28, 9, 8, 20, COL_TAB, COL_TAB, \
	                        [" ", ""], "?", \
				msg_YESNO)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    if yes == cmd_YES and self.request == FALSE:
		#     
		for oi in range(len(self.object_id)):
		    obj = self.object_id[oi]
		    #        
		    if self._fixobjects == 4:
			odocno = int(str(self.shift) + str(self.shift_indx))
		    else:
			odocno = getDoc_counter(doc_no = self.raznos_no, update = TRUE)    		
			
		    if self._fixobjects == 24:
			#self.transferCounter = getDoc_counter(doc_no = 201, update = TRUE)
			self.transferCounter = int(str(self.shift) + str(self.shift_indx))
		
		    if self._fixobjects == 24:
			self.createNewDocument(self.transferCounter, obj, docname = self.alt_raznos_name)
		    else:
			self.createNewDocument(odocno, obj)
		    for i in range(len(self.reqlist.items)):
			#          
			if self.reqlist.hidden_items[i][2] == obj:
			    self.addToDocument(i, odocno)
			    #if self._fixobjects == 24:
			    #	self.Transfer(i, 2, 4)
		return ev_QUIT
	    elif yes == cmd_YES and self.request == TRUE:
		strdate = self.edate.text
		doc_date = "20" + strdate[6:8] + "-" + strdate[3:5] + "-" + strdate[0:2]
		rdocno = getDoc_counter(doc_no = 70, update = TRUE)
		db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host = "192.168.0.2")
		curs = db.cursor()	
		for i in range(len(self.reqlist.items)):
		    #    
		    it = self.reqlist.items[i]
		    ih = self.reqlist.hidden_items[i]
		    curs.execute("""INSERT INTO requests (
		                    artid, artname, qnty_id,
				    tweight, tpacks, qnty,
				    price, rcd_price,
				    pack, 
				    counter, lineindx, doc_no, doc_date,
				    dan_no, 
				    fin_date,
				    date, oper) VALUES (
				    %s, %s, %s,
				    %s, %s, %s,
				    %s, %s,
				    %s,
				    %s, %s, %s, %s,
				    %s, 
				    NOW(),
				    NOW(), 'cv')""", (
				    it[0].Label, it[1].Label, it[2].Label,
				    it[3].Label, it[4].Label, it[5].Label,
				    it[6].Label, ih[1], 
				    ih[0],
				    rdocno, ih[4], self.raznos_no, doc_date,
				    self.Customer_dan_no))
				    
		db.close()
	    return ev_DONE
	    
	
	if command == cm_QUICK_SEARCH and args == 20:
	    srch = QuickSearchDlg(40, 17, 38, " ")
	    srch.mainLoop()
	    s = strip(srch.search.text)
	    srch.destroy()
	    del srch
	    if s == "":
		self.select(20)
		return ev_NONE

	    m = Message()
	    #m.message = cm_LOCATE
	    #m.args.append(None)
	    #m.args.append(s)
	    #m.args.append(1)
	    self.artlist.dbQuery = "SELECT CONCAT(articles.group_no, articles.art_no), articles.name, articles.qty_id, articles.weight, articles.pack1, sum(delivery.rest_qnty) FROM articles, delivery WHERE delivery.object_no = " + str(self.current_object) + " AND articles.object_no = delivery.object_no AND articles.group_no = delivery.group_no AND articles.art_no = delivery.art_no AND delivery.valid = 1 AND delivery.rest_qnty > 0 AND articles.name RLIKE \'" + s + "\' GROUP by 1 ORDER BY articles.name"
	    m.message = cm_RELOAD
	    found = self.artlist.Update(m)
	    curses.curs_set(0)
	    if found <= 0:
		msgbox = MessageBox(28, 14, 6, 20, COL_TAB, COL_TAB, \
		                        [" ",], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.artlist.dbQuery = "SELECT CONCAT(articles.group_no, articles.art_no), articles.name, articles.qty_id, articles.weight, articles.pack1, sum(delivery.rest_qnty) FROM articles, delivery WHERE delivery.object_no = " + str(self.current_object) + " AND articles.group_no = delivery.group_no AND articles.art_no = delivery.art_no AND delivery.valid = 1 AND delivery.rest_qnty > 0 GROUP by 1 ORDER BY articles.name"
		m = Message()
		m.message = cm_RELOAD
		self.artlist.Update(m)
		self.select(20)
	    return ev_NONE
	
	elif command == ev_ACTIVATE and args == curses.KEY_F6:
	    self.arttxt.SetText("/")
	    self.select(21)
	    return ev_NONE
	if command == ev_ACTIVATE and args == curses.KEY_F12 and self.control == 20:
	    if self.single.text == "":
		e1 = 0
	    else:
		e1 = float(self.single.text)
	    tqnty = self.checkQuantity() - e1
	    msgbox = MessageBox(57, 17, 7, 22, COL_TAB, COL_TAB, \
		                        ["",str(tqnty)], "", msg_OK)
	    msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()		    
	    self.select(20)
	    return ev_NONE	    

	    
	elif command == ev_ACTIVATE and args == curses.KEY_F1:
	    if self.control == 20:
		self.artlist.dbQuery = "SELECT CONCAT(articles.group_no, articles.art_no), articles.name, articles.qty_id, articles.weight, articles.pack1, sum(delivery.rest_qnty) FROM articles, delivery WHERE delivery.object_no = " + str(self.current_object) + " AND articles.object_no = delivery.object_no AND articles.group_no = delivery.group_no AND articles.art_no = delivery.art_no AND delivery.valid = 1 AND delivery.rest_qnty > 0 GROUP by 1 ORDER BY articles.name"
		m = Message()
		m.message = cm_RELOAD
		self.artlist.Update(m)
		self.single.SetText("")
		self.totalweight.SetText("")
		self.totalpack.SetText("") 
		self.artprice.SetText("") 		    
		self.select(20)
	    else:
		self.select(20)
	    self.arttxt.SetText(" ")
	    return ev_NONE
	elif command == ev_ACTIVATE and args == curses.KEY_F4:
	    self.current_object = self.getObject_no(self.objectBox.text)
	    #self.artlist.dbQuery = "SELECT CONCAT(group_no, art_no), name, qty_id, weight, pack1 FROM articles WHERE object_id = \'"+strip(self.objectBox.text)+"\'"
	    self.artlist.dbQuery = "SELECT CONCAT(articles.group_no, articles.art_no), articles.name, articles.qty_id, articles.weight, articles.pack1, sum(delivery.rest_qnty) FROM articles, delivery WHERE delivery.object_no = " + str(self.current_object) + " AND articles.group_no = delivery.group_no AND articles.art_no = delivery.art_no AND delivery.valid = 1 AND delivery.rest_qnty > 0 GROUP by 1 ORDER BY articles.name"
	    m = Message()
	    m.message = cm_RELOAD
	    self.artlist.Update(m)
	    return ev_DONE 
	if command == cm_CANDELETE:
	    msgbox = MessageBox(28, 9, 8, 20, COL_TAB, COL_TAB, \
	                        [" ", ""], "?", \
				msg_YESNO)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    if yes == cmd_YES:
		db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
		curs = db.cursor()	
		curs.execute("""DELETE FROM reserve WHERE
				operid = %s AND lineno = %s""",
				(self.userid, self.reqlist.hidden_items[self.reqlist.hilite][4]))
		db.close()
		return TRUE
	    else:
		return FALSE
	    
	if command == cm_UPDATE:
	    self.rq_total_weight = 0
	    self.rq_total_pack = 0
	    self.rq_total_price = 0
	    
	    self.writexy(44, 12, rjust(fix(self.rq_total_weight, 2), 9) + " ", COL_TITLE, bold = TRUE)
	    self.writexy(53, 12, rjust(fix(self.rq_total_pack, 2), 8) + " ", COL_TITLE, bold = TRUE)
	    self.writexy(62, 12, " :", COL_WARN, bold = TRUE)
	    self.writexy(68, 12, rjust(fix(self.rq_total_price,2), 10) + " " , COL_WARN, bold = TRUE)	    
	    
	    for i in range(len(self.reqlist.items)):
		it = self.reqlist.items[i]
		ww = float(it[3].Label)
		pck = float(it[4].Label)
		prc = float(it[6].Label)
		edbr = float(it[5].Label)
		self.rq_total_weight = self.rq_total_weight + ww
		self.rq_total_pack = self.rq_total_pack + pck
		#self.writexy(47, 12, rjust(str(self.rq_total_weight), 9), COL_TEXT, bold = TRUE)
		#self.writexy(59, 12, rjust(str(self.rq_total_pack), 8) + " ", COL_TEXT, bold = TRUE)
		
		s = edbr * prc
		self.rq_total_price = self.rq_total_price + s
		#self.writexy(68, 12, rjust(str(self.rq_total_price), 10) , COL_TEXT, bold = TRUE)	    		
		
		self.writexy(44, 12, rjust(fix(self.rq_total_weight, 2), 9) + " ", COL_TITLE, bold = TRUE)
		self.writexy(53, 12, rjust(fix(self.rq_total_pack, 2), 8) + " ", COL_TITLE, bold = TRUE)
		self.writexy(62, 12, " :", COL_WARN, bold = TRUE)
		self.writexy(68, 12, rjust(fix(self.rq_total_price,2), 10) + " " , COL_WARN, bold = TRUE)	    
		
	    return ev_NONE
	    
	return ev_NONE

    
    def addToDocument(self, itno, docno):
	strdate = self.edate.text
	if self._fixobjects == 4 or self._fixobjects == 24:
	    doc_date = strftime("%Y-%m-%d", gmtime())
	else:
	    doc_date = "20" + strdate[6:8] + "-" + strdate[3:5] + "-" + strdate[0:2]
	it = self.reqlist.items[itno]
	artcode = it[0].Label
	grno = artcode[0:2]
	arno = artcode[2:5]
	#    
	obj = self.reqlist.hidden_items[itno][2]
    	
	wid = it[2].Label # 
	ww = it[3].Label  # 
	tp = it[4].Label  #  
	br = it[5].Label  # .  
	pr = it[6].Label  # 
	
	weight = self.reqlist.hidden_items[itno][5]
	
	#       
	if strip(wid) == "." or strip(wid) == "":
	    qnty = float(br)
	elif strip(wid) == "." or strip(wid) == "":
	    qnty = float(ww)
			    
	rprice = self.reqlist.hidden_items[itno][1]
	p1 = self.reqlist.hidden_items[itno][0]
	
	db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host = "192.168.0.2")
	curs = db.cursor()	
	
	curs.execute("""SELECT rid, rest_qnty,
				    doc_no, doc_counter,
				    doc_date, 
				    partn_dn FROM delivery
				    WHERE
				    group_no = %s AND
				    art_no = %s AND
				    object_no = %s AND
				    rest_qnty > 0 AND 
				    valid = 1 ORDER BY doc_date""",
				    (grno, arno, obj))
	deliv = curs.fetchall()
	#self.scr.ShowInfo(info_common, str(deliv[0][0]) + " - " + str(tweight))
	for j in range(len(deliv)):
	    d1 = deliv[j]
	    #self.scr.ShowInfo(info_common, str(d1[0]) + " - " + str(tweight))
	    #      0 - 
	    if qnty == 0:
		break
	    if d1[1] < qnty:
		#    = 0
		qnty = qnty - d1[1]
		ton = d1[1] * weight
		curs.execute("""UPDATE delivery SET
					rest_qnty = 0 WHERE
					group_no = %s AND
					art_no = %s AND
					object_no = %s AND
					doc_no = %s AND
					doc_counter = %s AND
					doc_date = %s AND
					partn_dn = %s AND
					valid = 1""",
					(grno, arno, obj,
					d1[2], d1[3], d1[4], d1[5]))
		curs.execute("""INSERT INTO sales 
		                (group_no, art_no, object_no,
				partn_dn, doc_no, doc_counter, doc_date,
				qnty, qty_id,
				weight, packs,
				price, rprice,
				source_rid, source_no, palet,
				date, oper) VALUES (
				%s, %s, %s, 
				%s, %s, %s, %s,
				%s, %s,
				%s, %s,
				%s, %s,
				%s, %s, %s,
				NOW(), %s)""",
				(grno, arno, obj,
				 self.Customer_dan_no, self.raznos_no, docno,
				 doc_date,
				 d1[1], wid,
				 ton, tp,
				 pr, rprice,
				 d1[0], d1[3], self.palet,
				 "cv"))
		if self._fixobjects == 24:
		        dest_obj = 4
			source_dan_no = 2
		    	curs.execute("""INSERT INTO delivery (group_no, art_no, object_no, partn_dn, doc_no, doc_counter, doc_date, deliv_qnty, price, rest_qnty, valid, valid_date, valid_oper, source_ty, source_no, date, oper, source_rid) VALUES (%s, %s, %s, %s, %s, %s, NOW(), %s, %s, %s, %s, NOW(), %s, %s, %s, NOW(), %s, %s)""",
			                (grno, arno, dest_obj,
	                                source_dan_no, 
	                                201, self.transferCounter,
	                                d1[1], pr, d1[1], 
	                                1, "cv",
	                                self.raznos_no, docno, "nobody", d1[0]))

	    else:
		#
		#rest_qnty = rest_qnty - tweight
		ton = qnty * weight
		curs.execute("""UPDATE delivery SET
					rest_qnty = rest_qnty - %s WHERE
					group_no = %s AND
					art_no = %s AND
					object_no = %s AND
					doc_no = %s AND
					doc_counter = %s AND
					doc_date = %s AND
					partn_dn = %s AND
					valid = 1""",
					(qnty, grno, arno, obj,
					d1[2], d1[3], d1[4], d1[5]))			
		curs.execute("""INSERT INTO sales 
		                (group_no, art_no, object_no,
				partn_dn, doc_no, doc_counter, doc_date,
				qnty, qty_id,
				weight, packs,
				price, rprice,
				source_rid, source_no, palet,
				date, oper) VALUES (
				%s, %s, %s, 
				%s, %s, %s, %s,
				%s, %s,
				%s, %s,
				%s, %s,
				%s, %s, %s, 
				NOW(), %s)""",
				(grno, arno, obj,
				 self.Customer_dan_no, self.raznos_no, docno,
				 doc_date,
				 qnty, wid,
				 ton, tp,
				 pr, rprice,
				 d1[0], d1[3], self.palet,
				 "cv"))
		if self._fixobjects == 24:
		        dest_obj = 4
			source_dan_no = 2
		    	curs.execute("""INSERT INTO delivery (group_no, art_no, object_no, partn_dn, doc_no, doc_counter, doc_date, deliv_qnty, price, rest_qnty, valid, valid_date, valid_oper, source_ty, source_no, date, oper, source_rid) VALUES (%s, %s, %s, %s, %s, %s, NOW(), %s, %s, %s, %s, NOW(), %s, %s, %s, NOW(), %s, %s)""",
			                (grno, arno, dest_obj,
	                                source_dan_no, 
				        201, self.transferCounter,
	                                qnty, pr, qnty, 
	                                1, "cv",
	                                self.raznos_no, docno, "nobody", d1[0]))
				 
					
		qnty = 0
		
	db.close()
	
    def createNewDocument(self, counter, objid, objname= "  2", docname = None):
	if self._fixobjects <> 4 and self._fixobjects <> 24:
	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	    curs = db.cursor()	
	    curs.execute("""SELECT lname, bulst, address, city, mol, bank_ac FROM partners WHERE dan_no = %s AND ptype = 2""", (self.Customer_dan_no, ))
	    (lname, bulst, address, city, mol, bank_ac) = curs.fetchone()
	    db.close()
	    _bulst = ", . :" + ljust(bulst, 35)
	else:
	    lname = self.Customer
	    address = ""
	    mol = ""
	    city = ""
	    _bulst = "          " + ljust(" ", 35)
	    cntr = str(counter)
	    while len(cntr) < 10:
		cntr = "0" + cntr
	    counter = cntr
	    
				
	fp = open("razh"+str(counter), "w+")  
	fp.write(" :"+ljust(lname, 55) +     " : COMPANY xxx, ."+str(objid) + "\n")
	
	if self._fixobjects <> 4 and self._fixobjects <> 24:
	    fp.write("  .:"+ljust(self.Customer_dan_no, 10) + _bulst +  "   : 1201015274,  : 829097425\n")
	    fp.write("     :"+ljust(address, 55) +   "     : \n")
	    fp.write("       :"+ljust(mol, 55) +       "       : \n")
	    fp.write("      :"+ljust(city, 55) +      ".- :\n")
		
	    fp.write("\n")
	    fp.write("   : . GRAD\n")
	elif self._fixobjects == 4 or self._fixobjects == 24:
	    fp.write("\n\n")
	fp.write(": " + USER + " .............   : ....................\n")
	fp.write("\n")
	fp.write(" . ...................\n")
	fp.write("\n")
	if docname == None:
	    fp.write("                                                       "+strip(self.raznos_name))
	else:
	    fp.write("                                                       "+strip(docname))
	if self.palet == 1:
	    fp.write(" -   \n")
	else:
	    fp.write("\n")
	if self._fixobjects == 4 or self._fixobjects == 24:
	    fp.write("                                                No: "+ljust(str(counter), 15) + ":" + strftime("%d/%m/%y", gmtime()) + "\n")
	else:
	    fp.write("                                                No: "+ljust(str(counter), 15) + ":" + self.edate.text + "\n")
	fp.write("\n")
	fp.write("                                                                            " + OS_VER + "  " + SERVER_VER + "\n")
	fp.write("                                                                                                          "+strftime("%H:%M:%S", localtime()) + "\n")
	fp.write("+-----------------------------------------------------------------------------------------------------------------------------+\n")
	fp.write("| No ||                     || O | -|  .  |- |  20% |  | .|\n")
	fp.write("+-----------------------------------------------------------------------------------------------------------------------------+\n")
	tsum = 0
	tton = 0
	tstek = 0
	tsdds = 0
	td20  = 0
	for i in range(len(self.reqlist.items)):
	    if self.reqlist.hidden_items[i][2] == objid: 
		it = self.reqlist.items[i]
		indx = center(strip(it[0].Label), 5)
		artname = ljust(it[1].Label, 32)
		wid = center(it[2].Label, 5)
		ww = rjust(it[3].Label, 9)
		tp = it[4].Label
		qty = rjust(it[5].Label, 12)
		pr = rjust(it[6].Label, 10)
		tsum = tsum + float(qty) * float(pr)
		tton = tton + float(ww)
		tstek = tstek + float(tp)
		
		
		sum = rjust(fix(float(qty) * float(pr), 2), 10)
		
		suma_bez_dds = float(sum) / 1.2
		tsdds = tsdds + suma_bez_dds
		dds = suma_bez_dds * 0.2
		td20 = td20 + dds
		
		sbdds = rjust(fix(suma_bez_dds,2), 8)
		d20 = rjust(fix(dds,2), 9)
		
		p1 = self.reqlist.hidden_items[i][0]
	    
		fp.write("| " + ljust(str(i+1),3) + "|" +  indx + "| " + artname + "|"+wid+"|"+qty+"|"+ww+"| "+pr +"| "+sbdds + "|"+d20 + "|" + sum + "| " + tp+"|\n")
	    
	fp.write("+-----------------------------------------------------------------------------------------------------------------------------+\n")
	fp.write("|                                          : |             "+rjust(fix(tton,2),9) + "|            "+rjust(fix(tsdds,2),9)+"|"+rjust(fix(td20,2),9)+"|"+rjust(fix(tsum,2),10)+"|"+rjust(fix(tstek,2),8)+"|\n")	
	fp.write("+-----------------------------------------------------------------------------------------------------------------------------+\n")
	
	if self._fixobjects <> 4 and self._fixobjects <> 24:
	    fp.write("\n")
	    fp.write(":\n")
	    fp.write("\n")
	    fp.write(".-: .............................. : .................\n")
	    fp.write("\n")
	    fp.write("   : ..............................  : ................\n")
	    fp.write("\n    !   .\n")
	fp.write(".\n.\n.\n")
	fp.close()
	os.spawnlp(os.P_NOWAIT, './printdoc', './printdoc', 'razh'+str(counter))
	pass

    
#------------------------------------------------------------------------------
# 
class Fakturi(Dialog):
    def __init__(self, fak_name, fak_no):
	Dialog.__init__(self, 0, 0, 24, 79, COL_MAIN)
	self.set_caption("   " + fak_name)
	self.shift = shift
	self.shift_indx = counter
	self.Parent = parent
	
	self.artno1 = 0
	self.grno2 = 0
	self.artno2 = 0
	
	self.prod_brstek = 0
	self.prod_edbr = 0
	self.prod_pak = 1
	self.prod_gr = 0
	self.sum_dadeno = 0
	self.sum_ost = 0
	self.sum_prod = 0
	self.pr_price = 0
	
	#     
	self.lineindx = 0
	self.planline = 0
	
	self.DrawNo(self.shift)
	#0
	self.product = OptionLine(self, 2, 3, 33, "  ", pos_UP)
	self.addWidget(self.product)
	#1
	self.brstek = LabeledEditLine(self, 2, 5, 10, ".", pos_UP)
	self.brstek.SetText("0")
	self.brstek.setType(dt_numeric)
	self.addWidget(self.brstek)
	#2
	self.edbr = LabeledEditLine(self, 14, 5, 10, "+ . .", pos_UP)
	self.edbr.SetText("0")
	self.edbr.setType(dt_numeric)
	self.addWidget(self.edbr)
	#3
	self.pak = LabeledEditLine(self, 26, 5, 10, "  ", pos_UP)
	self.pak.SetText("1")
	self.pak.setType(dt_numeric)
	self.pak.Focusable = FALSE
	self.addWidget(self.pak)	
	#4
	self.gr =  LabeledEditLine(self, 38, 5, 10, "", pos_UP)
	self.gr.SetText("0")
	self.gr.setType(dt_float)
	self.gr.Focusable = FALSE
	self.addWidget(self.gr)	

	#5
	self.price = LabeledEditLine(self, 2, 7, 10, ".  :", pos_LEFT)
	self.price.setType(dt_float)
	self.price.SetText("0.0")
	self.addWidget(self.price)
	
	#6
	self.jlist = MultiListBox(self, 2, 9, 13, 75, COL_TEXT)
	self.jlist.setItemColors(COL_TITLE, COL_TEXT)
	self.jlist.MultiChoice = FALSE
	self.jlist.addColon(31, "")
	self.jlist.addColon(7, ".", dt_float, 0)
	self.jlist.addColon(7, ".", dt_float, 0)
	self.jlist.addColon(9, "", dt_float, 0)
	
	self.jlist.addColon(6, "", dt_float, 0)
	self.jlist.addColon(7, ".", dt_float, 3)
	self.jlist.addColon(8, "", dt_float, 4)
	
	self.addWidget(self.jlist)
	
	self.qtyid = LabeledEditLine(self, 50, 5, 8, "", pos_UP)
	self.qtyid.Focusable = FALSE
	self.addWidget(self.qtyid)
	
	self.AddHotKey(curses.KEY_F2, 0)
	self.AddHotKey(curses.KEY_F4, 0)	
	self.AddHotKey(curses.KEY_F10, 0)
	self.AddHotKey(curses.KEY_F8, 0)
	
	self.AddHotKey(curses.KEY_NPAGE, 0)
	self.AddHotKey(curses.KEY_PPAGE, 0)
	
	self.jlist.addNotifyRecipient(self, cm_ITEM_CHANGED)

	self.writexy(27, 23, " :                                             ", COL_WARN, TRUE)
	
	self.writexy(0, 24, "| F2 -  | PDn/PUp  | F8 -  | F10 - /. |            "  , COL_TITLE, TRUE)
	#self.CalculateSums()
	self.select(0)
	
    def DrawNo(self, no):
	self.writexy(67, 0, "    : " + str(no) + " ", COL_WARN)
	self.writexy(54, 0, "  : " + str(self.shift_indx) + " ", COL_WARN)
	if no == 1:
	    self.writexy(69, 2,"       ", COL_MAIN)
	    self.writexy(69, 3,"     ", COL_MAIN)
	    self.writexy(69, 4,"     ", COL_MAIN)
	    self.writexy(69, 5,"       ", COL_MAIN)
	    self.writexy(69, 6,"       ", COL_MAIN)
	    self.writexy(69, 7,"       ", COL_MAIN)
	elif no == 2:
	    self.writexy(69, 2,"  ", COL_MAIN)
	    self.writexy(69, 3,"    ", COL_MAIN)
	    self.writexy(69, 4,"      ", COL_MAIN)
	    self.writexy(69, 5,"      ", COL_MAIN)
	    self.writexy(69, 6,"      ", COL_MAIN)
	    self.writexy(69, 7,"", COL_MAIN)
	elif no == 3:
	    self.writexy(69, 2,"  ", COL_MAIN)
	    self.writexy(69, 3,"    ", COL_MAIN)
	    self.writexy(69, 4,"      ", COL_MAIN)
	    self.writexy(69, 5,"      ", COL_MAIN)
	    self.writexy(69, 6,"    ", COL_MAIN)
	    self.writexy(69, 7,"  ", COL_MAIN)
	    

    def CalculateSums(self):
	    
	for i in range(len(self.jlist.items)):
	    it = self.jlist.items[i]
	    self.total_prod = self.total_prod + float(it[5].Label)
	    
	self.writexy(64, 23, rjust(fix(self.total_prod, 0), 5) + "|", COL_WARN, TRUE)
	

    def Update(self, msg):
	pass
	#if msg.message == cm_ITEM_CHANGED:
	    #i = msg.args[1]
	    #self.product_info.SetText(self.jlist.hidden_items[i][2])


    def PrintDocument2(self, src_obj, dest_obj, doc_no, doc_counter):
	db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	curs = db.cursor()	
	curs.execute("""SELECT lname, bulst, address, city, mol, bank_ac FROM partners WHERE dan_no = %s AND ptype = 1""", (src_obj,))
	(lname, bulst, address, city, mol, bank_ac) = curs.fetchone()
	curs.execute("""SELECT name FROM documents WHERE doc_no = %s""", (doc_no,)) 
	(doc_name,) = curs.fetchone()
	db.close()
	
			
	fp = open("prih"+str(doc_counter), "w+")
	fp.write(" :" + ljust(lname, 45) + " :COMPANY xxx,  " + str(dest_obj) + "\n")
	fp.write("  .:" + ljust(str(src_obj), 14) + ". :"+ljust(bulst, 23) + "     :\n")
	fp.write("     :" + ljust(address + "-" + city, 45) + "/:\n")
	fp.write("       :" + ljust(mol, 45) + ". :\n")
	
	fp.write("\n")
	fp.write("                               " + doc_name + "\n")
	fp.write("                             No: "+ljust(str(doc_counter), 15) + ":" + strftime("%d/%m/%y", gmtime()) + "\n\n")
	fp.write("\n")
	fp.write("                                             " + OS_VER + "  " + SERVER_VER + "\n")
	fp.write("                                                                                   "+strftime("%H:%M:%S", localtime()) + "\n")
	fp.write("+----------------------------------------------------------------------------------------------+\n")
	fp.write("| No |   |                     |  |  | . |   |\n")
	fp.write("+----------------------------------------------------------------------------------------------+\n")
	totalsum = 0
	for i in range(len(self.jlist.items)):
	    it = self.jlist.items[i]
	    ih = self.jlist.hidden_items[i]
	    indx = center(str(ih[1])+str(ih[2]), 7)
	    artname = ljust(it[0].Label, 32)
	    wid = center(strip(ih[3]), 7)
	    
	    qnty = ljust(it[3].Label, 12)
	    
	    tp = it[4].Label
	    br = it[5].Label
	    
	    pr = rjust(it[6].Label, 12)
	    
	    sum = rjust(fix(float(qnty) * float(pr), 2), 10)
	    totalsum = totalsum + float(qnty) * float(pr)
		
	    fp.write("| " + ljust(str(i+1),3) + "| " +  indx + "| " + artname + "|"+wid+"|"+qnty+"| "+pr +"| "+sum + "|\n")
	    
	fp.write("+----------------------------------------------------------------------------------------------+\n")
	fp.write("|                                               |                                 "+rjust(fix(totalsum,2), 12)+" |\n")
	fp.write("+----------------------------------------------------------------------------------------------+\n")
	
	fp.write("\n")
	fp.write("         :\n")
	fp.write("\n  :" + USER + "...........    : ..........    : ..........\n\n*\n")
	fp.close()
	os.spawnlp(os.P_NOWAIT, './printdoc', './printdoc', 'prih'+str(doc_counter))
	pass
	    
	    
    def PrintDocument(self, src_obj):
	fp = open("proizv"+str(self.shift_indx) + "-" + str(self.shift), "w+")
	fp.write(" :  " + ljust(str(self.shift), 18) + " :COMPANY xx,  " + str(src_obj) + "\n")
	
	fp.write("\n")
	fp.write("                                \n")
	#fp.write("                        No: "+ljust(str(self.doc_counter), 15) + ":" + self.nowDate + "\n")
	fp.write(strftime("%d-%m-%Y : %H:%M:%S", localtime()) + "\n")
	fp.write("+----------------------------------------------------------------------------------+\n")
	fp.write("| No |   |                     |  |  | .  |\n")
	fp.write("+----------------------------------------------------------------------------------+\n")
	for i in range(len(self.jlist.items)):
	    it = self.jlist.items[i]
	    ih = self.jlist.hidden_items[i]
	    _grno = ih[1]
	    _artno = ih[2]
	    _price = float(it[6].Label)
	    _qnty = float(it[3].Label)
	    artcode = rjust(str(_grno)+str(_artno), 7)
	    artname = ljust(it[0].Label, 32)
	    wid = center(ih[3], 7)
	    #wid = center(it[2].Label, 7)
	    ww = rjust(fix(_qnty,3), 12)
	    pr = rjust(fix(_price,4), 13)
	    
	    fp.write("| " + ljust(str(i+1),3) + "| " +  artcode + "| " + artname + "|"+wid+"|"+ww+"|" + pr+"|\n")
	fp.write("+----------------------------------------------------------------------------------+\n")	    
	fp.write(": " + ljust(get_user(), 32) + "  /               /\n\n")
	fp.write(" : " + ljust(" ", 32) + "  /               /\n\n")
	
	    
	fp.close()
	os.spawnlp(os.P_NOWAIT, './printdoc', './printdoc', 'proizv'+str(self.shift_indx) + "-" + str(self.shift))
	
    def UserFn(self, command, args):
	if self.Parent.SCREEN_LOCKED == TRUE:
	    return ev_NONE
	if self.Parent.QUIT_STATUS == TRUE:
	    return ev_NONE
	
	if command == ev_ACTIVATE and args == curses.KEY_NPAGE:
	    self.jlist.handleEvent(curses.KEY_DOWN)
	    self.select(0)
	    return ev_NONE

	if command == ev_ACTIVATE and args == curses.KEY_PPAGE:
	    self.jlist.handleEvent(curses.KEY_UP)
	    self.select(0)
	    return ev_NONE
	
	if command == ev_ACTIVATE and args == curses.KEY_F4:
	    self.select(0)
	    return ev_NONE
	
	if command == ev_OPTION and args == 0:
	    artdlg = getArtID()
	    artdlg.mainLoop()
	    if artdlg.plist.hilite == -1:
		artdlg.destroy()
		del artdlg
		msgbox = MessageBox(28, 9, 8, 32, COL_TAB, COL_TAB, \
		                        ["  ", "   ", " !"], "", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()		
		self.select(1)
		return ev_NONE
	    
	    self.product.SetText(artdlg.plist.items[artdlg.plist.hilite][1].Label)
	    artid = artdlg.plist.items[artdlg.plist.hilite][0].Label
	    self.grno2 = artid[0:2]
	    self.artno2 = artid[2:5]
	    db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
	    curs = db.cursor()
	    curs.execute("""SELECT weight, pack1, qty_id FROM articles WHERE group_no = %s AND art_no = %s AND object_no = 2""",
 	    		(self.grno2, self.artno2))
	    (_weight, _pack, qty_id) = curs.fetchone()
	    db.close()
	    if _weight == 0:
		_weight = 0.1
	    if _pack == 0:
		_pack = 1
	    self.pak.SetText(str(_pack))
	    self.gr.SetText(str(_weight))
	    self.qtyid.SetText(str(qty_id))
	    if strip(self.qtyid.text) == "." or strip(self.qtyid.text) == "":
		self.edbr.Focusable = FALSE
	    else:
		self.edbr.Focusable = TRUE
	    
	    artdlg.destroy()
	    del artdlg
	    self.select(1)
	    return ev_NONE

	if command == ev_OK and args == 1:
	    self.prod_brstek = int(self.brstek.text)
	    if strip(self.qtyid.text) == "." or strip(self.qtyid.text) == "":
		self.select(5)
	    else:
		self.select(2)
	    return ev_NONE
	
	if command == ev_OK and args == 2:
	    self.prod_edbr = int(self.edbr.text)
	    if self.prod_brstek + self.prod_edbr == 0:
		msgbox = MessageBox(28, 9, 10, 32, COL_TAB, COL_TAB, \
		                        ["  ", "    !", "  ", "     ", "!"], "", msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		self.select(2)
		return ev_NONE

	    self.select(5)
	    return ev_NONE
	
	if command == ev_OK and args == 5:
	    self.pr_price = float(self.price.text)
	    self.select(1)
	    return ev_NONE
	    

	if command == ev_ACTIVATE and args == curses.KEY_F10:
	    if len(self.jlist.items) == 0:
		msgbox = MessageBox(28, 9, 8, 25, COL_TAB, COL_TAB, \
	                        ["   !", ""], " !", \
				msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		return ev_DONE
	    msgbox = MessageBox(28, 2, 7, 20, COL_TAB, COL_TAB, \
	                        [" "], "?", \
				msg_YESNO)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    if yes == cmd_YES:
		#    /   
		#pwd = PWDDialog(self.Parent, self.shift, self.shift_indx)
		#pwd.mainLoop()
		#_pwd = pwd.pwd.text
		#pwd.destroy()
		#del pwd
		#pflush()
		
		#if _pwd <> "cv":
		#    return ev_DONE

		odocno = str(self.shift) + str(self.shift_indx)    		
		dest_obj_doc_no = getDoc_counter(doc_no = 23, update = TRUE, oper = "")
		db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")#, host="192.168.0.2")
		curs = db.cursor()
		for i in range(len(self.jlist.items)):
		    it = self.jlist.items[i]
		    ih = self.jlist.hidden_items[i]
		    _grno = ih[1]
		    _artno = ih[2]
		    _qnty = float(it[3].Label)
		    _price = float(it[6].Label)
		    
		    _wid = ih[3]
		    _ton = _qnty * float(it[5].Label)
		    _pack = _qnty / float(it[4].Label)
		    
		    SRCOBJ = 4
		    SRCPARTNER = self.shift + 100
		    DESTPARTNER = 2
		    curs.execute("""INSERT INTO delivery
		                   (group_no, art_no, object_no,
				    partn_dn,
				    doc_no, doc_counter,
				    doc_date,
				    deliv_qnty, price, rest_qnty,
				    valid, valid_date, valid_oper,
				    source_ty, source_no,
				    date, oper)
				    VALUES (%s, %s, %s,
				    %s,
				    %s, %s,
				    NOW(),
				    %s, %s, %s,
				    %s, NOW(), %s,
				    %s, %s,
				    NOW(), %s)""",
	    		    (int(_grno), int(_artno), SRCOBJ, 
	    		    SRCPARTNER, 
	    		    200, int(odocno),
	    		    _qnty, _price, 0, 
	    		    1, odocno,
	    		    0, 0, 
	    		    "proizv"))
			    
		    #     sales .  
		    
		    curs.execute("""INSERT INTO sales 
		                (group_no, art_no, object_no,
				partn_dn, doc_no, doc_counter, doc_date,
				qnty, qty_id,
				weight, packs,
				price, rprice,
				source_rid, source_no,
				date, oper) VALUES (
				%s, %s, %s, 
				%s, %s, %s, LEFT(NOW(), 10),
				%s, %s,
				%s, %s,
				%s, %s,
				LAST_INSERT_ID(), %s, 
				NOW(), %s)""",
				(int(_grno), int(_artno), SRCOBJ,
				 DESTPARTNER, 23, int(dest_obj_doc_no),
				 _qnty, _wid,
				 _ton, _pack,
				 _price, _price,
				 int(odocno),
				 "proizv"))
		    
			    
		    DESTOBJ = 2
		    DESTPARTNER = SRCOBJ
		    curs.execute("""INSERT INTO delivery
		                   (group_no, art_no, object_no,
				    partn_dn,
				    doc_no, doc_counter,
				    doc_date,
				    deliv_qnty, price, rest_qnty,
				    valid, valid_date, valid_oper,
				    source_ty, source_no, source_rid,
				    date, oper)
				    VALUES (%s, %s, %s,
				    %s,
				    %s, %s,
				    NOW(),
				    %s, %s, %s,
				    %s, NOW(), %s,
				    %s, %s, LAST_INSERT_ID(),
				    NOW(), %s)""",
	    		    (int(_grno), int(_artno), DESTOBJ, 
	    		    DESTPARTNER, 
	    		    23, int(dest_obj_doc_no),
	    		    _qnty, _price, _qnty, 
	    		    1, int(odocno),
	    		    200, int(odocno),
	    		    "cv"))

			    
			    
		db.close()		
		self.PrintDocument(SRCOBJ)
		self.PrintDocument2(SRCOBJ, DESTOBJ, 23, dest_obj_doc_no)
		return ev_QUIT
		
	    return ev_DONE
	
	
	if command == ev_ACTIVATE and args == curses.KEY_F8:
	    it = self.jlist.items[self.jlist.hilite]
	    ih = self.jlist.hidden_items[self.jlist.hilite]
	    
	    msgbox = MessageBox(28, 9, 8, 26, COL_TAB, COL_TAB, \
		                        ["  ", "  "], "?", msg_YESNO)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    if yes == cmd_CANCEL:
		return ev_NONE
	    
	    self.planline = 0
	    self.writexy(49, 7, "                  ", COL_TEXT1)
	    self.writexy(49, 8, "          ", COL_TEXT1)
	    
	    self.product.SetText(strip(it[0].Label))
	    self.grno2 = int(ih[1])
	    self.artno2 = int(ih[2])
	 
	    self.brstek.SetText(strip(it[1].Label))
	    self.edbr.SetText(strip(it[2].Label))
	    self.pak.SetText(strip(it[4].Label))
	    self.gr.SetText(strip(it[5].Label))
	    self.price.SetText(strip(it[6].Label))
	    self.qtyid.SetText(strip(ih[3]))
	    
	    self.prod_brstek = int(self.brstek.text)
	    self.prod_edbr = int(self.edbr.text)
	    self.pr_rpice = float(self.price.text)
	    
	    self.jlist.items.remove(it)
	    self.jlist.hidden_items.remove(ih)
	    self.jlist.handleEvent(curses.KEY_HOME)
	    #self.CalculateSums()
	    self.select(0)
	
	if command == ev_ACTIVATE and args == curses.KEY_F2:
	    self.prod_brstek = int(self.brstek.text)
	    self.prod_edbr = int(self.edbr.text)
	    self.pr_rpice = float(self.price.text)
	    
	    if self.prod_brstek + self.prod_edbr == 0 or \
	       self.product.text == "" or \
	       self.pr_price == 0:
		msgbox = MessageBox(28, 9, 8, 25, COL_TAB, COL_TAB, \
	                        ["  ", "  !"], " !", \
				msg_OK)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		return ev_DONE
	    
	    self.lineindx = self.lineindx + 1
	    _pack = int(self.pak.text)
	    self.jlist.addItem([self.product.text,\
				str(self.prod_brstek), \
				str(self.prod_edbr), \
				str(_pack * self.prod_brstek + self.prod_edbr),\
				str(_pack),
				self.gr.text,
				self.price.text],
				hidden = [self.lineindx,\
					  self.grno2,\
					  self.artno2, 
					  strip(self.qtyid.text)])
	    self.jlist.draw()
	    
	    self.product.SetText("")
	    self.brstek.SetText("0")
	    self.edbr.SetText("0")
	    self.pak.SetText("1")
	    self.gr.SetText("0")
	    self.price.SetText("0.0")
	    #self.CalculateSums()
		
	    self.select(0)
	    return ev_NONE
    
