import os, re
from  defs import *
import curses
from curses import panel
import ui
from ui import *
from  MySQLdb import *
from time import gmtime, strftime, localtime



class PackReturn(Dialog):
    def __init__(self, obj_no, obj_name, partner, dan_no, doc_no, doc_name, counter, future = 1):
	self.partner = partner
	self.dan_no = dan_no
	self.doc_no = doc_no
	self.doc_name = doc_name
	self.doc_counter = counter
	self.future_delivery = future
	self.object_no = obj_no
	self.object_name = obj_name
	
	self.rq_total_weight = 0
	self.rq_total_pack = 0
	self.rq_total_price = 0
	
	self.nowday = strftime("%d/%m/%y", gmtime())
	self.nowDate = self.nowday
	
	Dialog.__init__(self, 0, 0, 24,  79, COL_MAIN)
	self.set_caption("   ")

	self.artlist = MultiListBox(self, 1, 17, 6, 77, COL_TEXT)	
	self.artlist.MultipleChoice(FALSE)
	self.artlist.setItemColors(COL_TITLE, COL_TEXT)
	self.artlist.Focusable = TRUE
	self.artlist.dbQuery = "SELECT CONCAT(group_no, art_no), name, qty_id, weight, pack1 FROM articles WHERE object_no = " + str(self.object_no) + " AND group_no <> 9 ORDER BY name"
	self.artlist.addColon(6, ".")
	self.artlist.addColon(31, "")
	self.artlist.addColon(5, "/")
	self.artlist.addColon(6, ".")
	self.artlist.addColon(6, ".")	
	m = Message()
	m.message = cm_RELOAD
	self.artlist.Update(m)
		
	#0
	self.addWidget(Label(self, 3, 1, " :", COL_TEXT1))
	self.objectBox = Label(self, 16, 1, self.object_name, COL_TEXT1)
	#1
	self.addWidget(self.objectBox)    
	#2
	self.addWidget(Label(self, 3, 2, ":", COL_TEXT1))
	#3
	self.addWidget(Label(self, 60, 2, ".", COL_TEXT1))
	#4
	self.addWidget(Label(self, 60, 1, "", COL_TEXT1))    
	self.set_color(COL_MAIN)
	#self.win.hline(3, 1, curses.ACS_BSSB, 78, 5)
	self.win.hline(13, 1, curses.ACS_BSSB, 78, 5)	
	#5
	self.addWidget(Label(self, 66, 1, self.nowDate, COL_TEXT))
	#6
	self.addWidget(Label(self, 2, 14, "/", COL_TEXT1))
	self.arttxt = EditLine(self, 2, 15, 20, COL_TEXT, COL_TITLE)    
	self.arttxt.Focusable = FALSE
	#7
	self.addWidget(Label(self, 14, 2, self.partner + "-" + self.dan_no, COL_MAIN))
	#8
	self.addWidget(Label(self, 66, 2, self.doc_counter, COL_TEXT1))
	#9
	self.addWidget(Label(self, 36, 1, self.doc_name, COL_WARN))
	#10
	self.addWidget(Label(self, 25, 14, ".", COL_TEXT1))	
	self.single = EditLine(self, 25,  15, 9, COL_TEXT, COL_TITLE)	
	self.single.setType(dt_float)
	#11
	self.addWidget(Label(self, 66, 14, ".", COL_TEXT1))
	self.artweight = EditLine(self, 66,  15, 4, COL_TEXT, COL_TITLE)
	self.artweight.Focusable = FALSE
	#12
	self.addWidget(Label(self, 45, 14, "", COL_TEXT1))
	self.totalweight = EditLine(self, 45,  15, 9, COL_TEXT, COL_TITLE)
	self.totalweight.setType(dt_float)
	#13
	self.addWidget(Label(self, 72, 14, "/", COL_TEXT1))	
	self.artpack = EditLine(self, 72,  15, 5,  COL_TEXT, COL_TITLE)	
	self.artpack.Focusable = FALSE
	#14
	self.addWidget(Label(self, 36, 14, ".", COL_TEXT1))	
	self.totalpack = EditLine(self, 36,  15, 7, COL_TEXT, COL_TITLE)	
	self.totalpack.setType(dt_float)
	
	#15	
	self.addWidget(Label(self, 56, 14, ".", COL_TEXT1))	
	self.artprice = EditLine(self, 56,  15, 8, COL_TEXT, COL_TITLE)	
	self.artprice.setType(dt_float)
	#16
	self.addWidget(self.arttxt)
	#17
	self.addWidget(self.single)
	#18
	self.addWidget(self.totalpack)
	#19
	self.addWidget(self.totalweight)	
	#20
	self.addWidget(self.artprice)	
	#21
	self.addWidget(self.artweight)
	#22
	self.addWidget(self.artpack)		
	#23
	self.addWidget(self.artlist)
	
	self.reqlist = MultiListBox(self, 1, 3, 8, 77, COL_TEXT)
	self.reqlist.MultipleChoice(FALSE)
	self.reqlist.setItemColors(COL_TITLE, COL_TEXT)
	self.reqlist.Focusable = TRUE
	self.reqlist.delPermitted = TRUE
	self.reqlist.addColon(6, ".")
	self.reqlist.addColon(31, "")
	self.reqlist.addColon(5, "/")
	self.reqlist.addColon(10, "  ", dt_float, 2)
	self.reqlist.addColon(8, "", dt_float, 2)	
	self.reqlist.addColon(10, ".", dt_float, 2)
	self.reqlist.addColon(7, "", dt_float, 4)
		
	self.reqlist.Update()
	#24
	self.addWidget(self.reqlist)	
	
	self.arttxt.addNotifyRecipient(self.artlist, cm_RELOAD, "\'")
	self.artlist.addNotifyRecipient(self.artweight, cm_UPDATE, 3)
	self.artlist.addNotifyRecipient(self.artpack, cm_UPDATE, 4)	

	self.writexy(2, 24, " | F1 -  | F6 - . | F10 -  | ", COL_TITLE, bold = TRUE)
	self.writexy(62, 12, " :", COL_WARN, bold = TRUE)
	self.writexy(38, 12, " : ", COL_TEXT)
	
	self.AddHotKey(curses.KEY_F1, 23)
	self.AddHotKey(curses.KEY_F10, 16)	
	self.AddHotKey(curses.KEY_F6, 24)
	self.select(23)

	
    def mainLoop(self):
	while 1:
	    status = Dialog.mainLoop(self)
	    if status == ev_FAIL and self.quitstatus == 1:
		msgbox = MessageBox(28, 9, 8, 26, COL_TAB, COL_TAB, \
		                        ["  ", "  "], "?", msg_YESNO)
		yes = msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		if yes == cmd_YES:
		    break
		else:
		    self.select(self.control)
		    self.quitstatus = 0
	    if status == ev_OK:
		break
	

    def PrintDocument(self):
	db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
	curs = db.cursor()	
	curs.execute("""SELECT lname, bulst, address, city, mol, bank_ac FROM partners WHERE dan_no = %s AND ptype = 1""", (self.dan_no,))
	(lname, bulst, address, city, mol, bank_ac) = curs.fetchone()
	db.close()
	
			
	fp = open("prih"+str(self.doc_counter), "w+")
	fp.write(" :" + ljust(lname, 45) + " : COMPANY xx," + self.object_name + "\n")
	fp.write("  .:" + ljust(self.dan_no, 14) + ". :"+ljust(bulst, 23) + "     :xx\n")
	fp.write("     :" + ljust(address + "-" + city, 45) + "/:\n")
	fp.write("       :" + ljust(mol, 45) + ". :\n")
	
	fp.write("\n")
	if self.future_delivery == 0:
	    fp.write("                                    \n")
	else:
	    fp.write("                               " + self.doc_name + "\n")
	fp.write("                             No: "+ljust(str(self.doc_counter), 15) + ":" + self.nowDate + "\n\n")
	fp.write("\n")
	fp.write("                                             " + OS_VER + "  " + SERVER_VER + "\n")
	fp.write("                                                                                   "+strftime("%H:%M:%S", localtime()) + "\n")
	fp.write("+---------------------------------------------------------------------------------------------+\n")
	fp.write("| No |   |                     |  |  | .  |   |\n")
	fp.write("+---------------------------------------------------------------------------------------------+\n")
	totalsum = 0
	for i in range(len(self.reqlist.items)):
	    it = self.reqlist.items[i]
	    indx = center(strip(it[0].Label), 7)
	    obid = 2
	    artname = ljust(it[1].Label, 32)
	    wid = center(it[2].Label, 7)
	    ww = ljust(it[3].Label, 12)
	    tp = it[4].Label
	    br = it[5].Label
	    pr = rjust(it[6].Label, 11)
	    sum = "0"
	    rpr = self.reqlist.hidden_items[i][1]
	    p1 = self.reqlist.hidden_items[i][0]	
	    
	    #       
	    if strip(wid) == "." or strip(wid) == "":
		qnty = float(br)
	    elif strip(wid) == "." or strip(wid) == "":
		qnty = float(ww)
	    
	    ww = rjust(str(qnty), 12)
	    sum = rjust(fix(qnty * float(pr), 2), 10)
	    totalsum = totalsum + qnty * float(pr)
		
	    #if strip(it[2].Label) == ".":
	    #	np = float(tp) * int(p1)
	    #	ww = ljust(str(np), 12)
	    #	sum = rjust(str(np * float(pr)), 10)
		
	    fp.write("| " + ljust(str(i+1),3) + "| " +  indx + "| " + artname + "|"+wid+"|"+ww+"| "+pr +"| "+sum + "|\n")
	    
	fp.write("+---------------------------------------------------------------------------------------------+\n")
	fp.write("|                                               |                                 "+rjust(fix(totalsum,2), 12)+"|\n")
	fp.write("+---------------------------------------------------------------------------------------------+\n")
	
	fp.write("\n")
	fp.write("         :\n")
	fp.write("\n  :" + USER + "...........    : ..........    : ..........\n\n*\n")
	fp.close()
	os.spawnlp(os.P_NOWAIT, './printdoc', './printdoc', 'prih'+str(self.doc_counter))
	pass
	
    def UserFn(self, command, args = None):
	if command == ev_OK:
	    if args == 17:
		if self.single.text == "":
		    self.select(18)
		    return
		edbr = int(self.single.text)
		weight = float(self.artweight.text)
		if weight == 0: weight = 1
		pack = int(self.artpack.text)
		if pack == 0: pack = 1
		
		wid = self.artlist.items[self.artlist.hilite][2].Label
		totalweight = edbr * weight
		self.totalweight.SetText(str(totalweight))
		totalpack = float(float(edbr) / float(pack))
		self.totalpack.SetText(fix(totalpack,2))
		ac = self.artlist.items[self.artlist.hilite][0].Label		
		#price = self.getPrices(ac, totalpack, totalweight)
		#self.artprice.SetText(str(price))
		self.select(20)
		return 
	    
	    if args == 23: #  
		#ar1 = ''
		#am1 = re.compile(ar1)
		#f = am1.match(self.artlist.items[self.artlist.hilite][1].Label)
		wid = strip(self.artlist.items[self.artlist.hilite][2].Label)
		f = find(self.artlist.items[self.artlist.hilite][1].Label, "", 0)
		if f > 0 or wid == "" or wid == ".":
		    #self.single.SetText("--")
		    self.select(19)
		else:
		    self.select(18)
		return ev_NONE
	    
	    if args ==  24: #  
		return ev_DONE
	    if args == 19 and self.totalweight.text <> "":
		wid = strip(self.artlist.items[self.artlist.hilite][2].Label)
		weight = float(self.artweight.text)
		if weight == 0: weight = 1
		pack = int(self.artpack.text)
		if pack == 0: pack = 1
		totalweight = float(self.totalweight.text)
		if wid == "." or wid == "":
		    totalpack = round((totalweight / weight) / pack)
		    self.totalpack.SetText(str(totalpack))
		    totalweight = totalpack * pack * weight
		    self.totalweight.SetText(str(totalweight))
		    br = float(totalpack) * pack
		
		elif wid == "." or wid == "":
		    totalpack = (totalweight / weight) / pack
		    self.totalpack.SetText(str(totalpack))
		    br = float(totalweight)
		    
		br = str(br)
		self.single.SetText(br)
		
		ac = self.artlist.items[self.artlist.hilite][0].Label
		grc = ac[0:2]
		arc = ac[2:5]
#		self.writexy(60, 1, grc, COL_WARN)
#		self.writexy(65, 1, arc, COL_WARN)
		
		#price = self.getPrices(ac, totalpack, totalweight)
		#self.artprice.SetText(str(price))
		self.nextWidget()
		return ev_NONE
	    if args == 18 and self.totalpack.text <> "":
		totalpack = float(self.totalpack.text)
		pack = int(self.artpack.text)
		if pack == 0:
		    pack = 1
		weight = float(self.artweight.text)
		if weight == 0:
		    weight = 1
		totalweight = str(totalpack * pack * weight)
		self.totalweight.SetText(totalweight)
		self.artprice.SetText("")
		
		wid = strip(self.artlist.items[self.artlist.hilite][2].Label)
		if wid == "." or wid == "":
		    br = float(totalpack) * pack
		elif wid == "." or wid == "":
		    br = float(totalweight)
		    
		br = str(br)
		self.single.SetText(br)		
		
	    if args == 23:
		self.select(18)
		return ev_NONE
	    if args == 20:
		itno = self.artlist.hilite
		if itno >= 0:
		    artcode = self.artlist.items[itno][0].Label
		    art_name = self.artlist.items[itno][1].Label
		    wid = self.artlist.items[itno][2].Label
		    tw = self.totalweight.text
		    tp = self.totalpack.text
		    pr = self.artprice.text
		    #pr1 = str(self.getPrices(artcode, float(tp), float(tw)))
		    #if pr == "":
			#pr = pr1

		    if strip(wid) == "." or strip(wid) == "":
			#br = float(tp) * int(self.artpack.text)
			br1 = float(self.single.text)
		    elif strip(wid) == "." or strip(wid) == "":
			#br = float(tw)
			br1 = float(self.totalweight.text)
		    
		    br = str(br1)
			
		    self.reqlist.addItem([artcode, art_name, wid, tw, tp, br, pr], hidden = [int(self.artpack.text), 0])
		    self.reqlist.draw()
		    sum = br1 * float(pr)
		    self.rq_total_weight = self.rq_total_weight + float(tw)
		    self.rq_total_pack = self.rq_total_pack + float(tp)
		    self.rq_total_price = self.rq_total_price + sum
		    #self.writexy(50, 12, rjust(str(self.rq_total_weight), 9), COL_TEXT, bold = TRUE)
		    #self.writexy(59, 12, rjust(str(self.rq_total_pack), 8) + " ", COL_TEXT, bold = TRUE)
		    #self.writexy(68, 12, rjust(str(self.rq_total_price), 10) , COL_TEXT, bold = TRUE)	    
		    
		    self.writexy(44, 12, rjust(fix(self.rq_total_weight, 2), 9) + " ", COL_TITLE, bold = TRUE)
		    self.writexy(53, 12, rjust(fix(self.rq_total_pack, 2), 8) + " ", COL_TITLE, bold = TRUE)
		    self.writexy(62, 12, " :", COL_WARN, bold = TRUE)
		    self.writexy(68, 12, rjust(fix(self.rq_total_price,2), 10) + " " , COL_WARN, bold = TRUE)	    
		    
		    
		    self.totalweight.SetText("")
		    self.totalpack.SetText("")
		    self.artprice.SetText("")
		    self.single.SetText("")
		self.select(23)
		return ev_NONE
	    if args == 16: #  
		if self.artlist.hilite == -1:
		    msgbox = MessageBox(28, 9, 6, 20, COL_TAB, COL_TAB, \
		                        [" "], "", msg_OK)
		    msgbox.mainLoop()
		    msgbox.destroy()
		    del msgbox
		    pflush()
		    self.select(16)
		    return ev_NONE
		else:
		    self.totalpack.SetText("")
		    self.totalweight.SetText("")
		    self.artprice.SetText("")
		    self.select(23) #  
		    return ev_NONE
	    else:
		self.nextWidget()
		return ev_NONE
	    
	if command == ev_FAIL:
	    if args == 20:
		self.select(14)
		return ev_NONE
	if command == ev_ACTIVATE and args == curses.KEY_F10:
	    msgbox = MessageBox(28, 9, 8, 20, COL_TAB, COL_TAB, \
	                        [" ", ""], "?", \
				msg_YESNO)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    if yes == cmd_YES:
		db = MySQLdb.connect(user = "cv", passwd="cv", db="eso")
		curs = db.cursor()
	    
		for i in range(len(self.reqlist.items)):
		    it = self.reqlist.items[i]
		    indx = it[0].Label
		    grno = indx[0:2]
		    arno = indx[2:5]
		    obid = self.object_no
		    wid = strip(it[2].Label)
		    ww = it[3].Label
		    tp = it[4].Label
		    br = it[5].Label
		    pr = it[6].Label
		    rpr = self.reqlist.hidden_items[i][1]
		    p1 = self.reqlist.hidden_items[i][0]
		    
		    #       
		    if wid == "." or wid == "":
			qnty = float(br)
		    elif wid == "." or wid == "":
			qnty = float(ww)
		    
		    #if strip(it[2].Label) == ".":
		    #	weight=float(ww)
		    #	packs=float(tp)
		    #	ip1 = int(p1)
		    #	npacks = packs * ip1
		    #	ww = str(npacks)
		  	
		    curs.execute("""INSERT INTO delivery (group_no, art_no, object_no, partn_dn, doc_no, doc_counter, doc_date, deliv_qnty, price, rest_qnty, valid, valid_date, valid_oper, source_ty, source_no, date, oper) VALUES (%s, %s, %s, %s, %s, %s, NOW(), %s, %s, %s, %s, NOW(), %s, %s, %s, NOW(), %s)""",
				  (int(grno), int(arno), obid,
				  self.dan_no, 
				  int(self.doc_no), int(self.doc_counter),
				  qnty, pr, qnty, 
				  self.future_delivery, "cv",
				  0, 0, 
				  "nobody"))
		db.close()		  
		self.PrintDocument()
		return ev_QUIT
		
	    return

	if command == cm_QUICK_SEARCH and args == 23:
	    srch = QuickSearchDlg(40, 17, 38, " ")
	    srch.mainLoop()
	    s = strip(srch.search.text)
	    srch.destroy()
	    del srch
	    if s == "":
		self.select(23)
		return ev_NONE

	    m = Message()
	    #m.message = cm_LOCATE
	    #m.args.append(None)
	    #m.args.append(s)
	    #m.args.append(1)
	    #self.artlist.dbQuery = "SELECT CONCAT(articles.group_no, articles.art_no), articles.name, articles.qty_id, articles.weight, articles.pack1, sum(delivery.rest_qnty) FROM articles, delivery WHERE delivery.object_no = " + str(self.current_object) + " AND articles.object_no = delivery.object_no AND articles.group_no = delivery.group_no AND articles.art_no = delivery.art_no AND delivery.valid = 1 AND delivery.rest_qnty > 0 AND articles.name RLIKE \'" + s + "\' GROUP by 1 ORDER BY articles.name"
	    self.artlist.dbQuery = "SELECT CONCAT(group_no, art_no), name, qty_id, weight, pack1 FROM articles WHERE object_no = " + str(self.object_no) + " AND name RLIKE \'" + s + "\' AND group_no <> 9 ORDER BY name"
	    m.message = cm_RELOAD
	    found = self.artlist.Update(m)
	    curses.curs_set(0)
	    if found <= 0:
		msgbox = MessageBox(28, 14, 6, 20, COL_TAB, COL_TAB, \
		                        [" ",], "", msg_OK)
		msgbox.mainLoop()
		msgbox.destroy()
		del msgbox
		pflush()
		#self.artlist.dbQuery = "SELECT CONCAT(articles.group_no, articles.art_no), articles.name, articles.qty_id, articles.weight, articles.pack1, sum(delivery.rest_qnty) FROM articles, delivery WHERE delivery.object_no = " + str(self.current_object) + " AND articles.group_no = delivery.group_no AND articles.art_no = delivery.art_no AND delivery.valid = 1 AND delivery.rest_qnty > 0 GROUP by 1 ORDER BY articles.name"
		self.artlist.dbQuery = "SELECT CONCAT(group_no, art_no), name, qty_id, weight, pack1 FROM articles WHERE object_no = " + str(self.object_no) + " AND group_no <> 9 ORDER BY name"
		m = Message()
		m.message = cm_RELOAD
		self.artlist.Update(m)
		self.select(23)
	    return ev_NONE
	
	
	elif command == ev_ACTIVATE and args == curses.KEY_F6:
	    return ev_OK
	elif command == ev_ACTIVATE and args == curses.KEY_F1:
	    if self.control == 23:
		self.artlist.dbQuery = "SELECT CONCAT(group_no, art_no), name, qty_id, weight, pack1 FROM articles WHERE object_no = " + str(self.object_no) + " AND group_no <> 9 ORDER BY name"
		m = Message()
		m.message = cm_RELOAD
		self.artlist.Update(m)
		self.select(23)
	    else:
		self.select(23)
	    return ev_OK
	
	if command == cm_CANDELETE:
	    msgbox = MessageBox(28, 9, 8, 20, COL_TAB, COL_TAB, \
	                        [" ", ""], "?", \
				msg_YESNO)
	    yes = msgbox.mainLoop()
	    msgbox.destroy()
	    del msgbox
	    pflush()
	    if yes == cmd_YES:
		return TRUE
	    else:
		return FALSE
	
	
	if command == cm_UPDATE:
	    self.rq_total_weight = 0
	    self.rq_total_pack = 0
	    self.rq_total_price = 0
	    
	    self.writexy(50, 12, rjust(str(self.rq_total_weight), 9), COL_TEXT, bold = TRUE)
	    self.writexy(59, 12, rjust(str(self.rq_total_pack), 8) + " ", COL_TEXT, bold = TRUE)
	    self.writexy(68, 12, rjust(str(self.rq_total_price), 10) , COL_TEXT, bold = TRUE)	    		
	    
	    for i in range(len(self.reqlist.items)):
		it = self.reqlist.items[i]
		ww = float(it[3].Label)
		pck = float(it[4].Label)
		prc = float(it[6].Label)
		edbr = float(it[5].Label)
		self.rq_total_weight = self.rq_total_weight + ww
		self.rq_total_pack = self.rq_total_pack + pck
		self.writexy(50, 12, rjust(str(self.rq_total_weight), 9), COL_TEXT, bold = TRUE)
		self.writexy(59, 12, rjust(str(self.rq_total_pack), 8) + " ", COL_TEXT, bold = TRUE)
		
		s = edbr * prc
		self.rq_total_price = self.rq_total_price + s
		self.writexy(68, 12, rjust(str(self.rq_total_price), 10) , COL_TEXT, bold = TRUE)	    		
		
	    return ev_NONE
	    
	return ev_NONE
